// -------------------------------------------------------------------------------
// 
// 		cwCu		`揈vO( Direct3D11 )wb_t@C
// 
// 				Ver 3.17c
// 
// -------------------------------------------------------------------------------

#ifndef __DXGRAPHICSD3D11_H__
#define __DXGRAPHICSD3D11_H__

#include "../DxCompileConfig.h"

#ifndef DX_NON_GRAPHICS

#ifndef DX_NON_DIRECT3D11

// CN[h ------------------------------------------------------------------
#include "../DxLib.h"
#include "../DxGraphics.h"
#include "../DxArchive_.h"
#include "DxGraphicsAPIWin.h"
#include "DxShader_DataType_D3D11.h"
#include "DxShader_PS_D3D11.h"
#include "DxShader_VS_D3D11.h"

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------

#define GD3D11										GraphicsHardDataDirect3D11

// 񋓂A_v^[̍ő吔
#define DX_D3D11_MAX_ADAPTER_LISTUP					(16)

// 񋓂AEgvbg̍ő吔
#define DX_D3D11_MAX_OUTPUT_LISTUP					(32)

// o͐EChE̍ő吔
#define DX_D3D11_MAX_OUTPUTWINDOW					(256)

// ǗeNX`ւ̃f[^]pVXezueNX`̐
#define DIRECT3D11_SYSMEMTEXTURE_NUM				(2048)

// ǗeNX`ւ̃f[^]pVXezuT[tFX̐
#define DIRECT3D11_SYSMEMSURFACE_NUM				(2048)

// @\x̐
#define DIRECT3D11_FEATURE_LEVEL_NUM				(7)

// obNobt@̃tH[}bg
#define DIRECT3D11_BACKBUFFER_FORMAT				D_DXGI_FORMAT_R8G8B8A8_UNORM

// 16rbg[xobt@Texture2DtH[}bg
#define DIRECT3D11_DEPTHBUFFER_TEXTURE2D_FORMAT		D_DXGI_FORMAT_D16_UNORM

// 16rbg[xobt@DepthStenciltH[}bg
#define DIRECT3D11_DEPTHBUFFER_DEPTHSTENCIL_FORMAT	D_DXGI_FORMAT_D16_UNORM

// ftHgTv[Xe[g̃tB^[[h̐
#define DIRECT3D11_DEFAULTRS_FILTER_NUM				(18)

// Graphics_D3D11_DrawPreparation ֐ɓntO
#define DX_D3D11_DRAWPREP_TRANS				(0x00001)
#define DX_D3D11_DRAWPREP_VECTORINT			(0x00002)
#define DX_D3D11_DRAWPREP_GOURAUDSHADE		(0x00008)
#define DX_D3D11_DRAWPREP_PERSPECTIVE		(0x00010)
#define DX_D3D11_DRAWPREP_DIFFUSERGB		(0x00020)
#define DX_D3D11_DRAWPREP_DIFFUSEALPHA		(0x00040)
#define DX_D3D11_DRAWPREP_FOG				(0x00080)
#define DX_D3D11_DRAWPREP_NOBLENDSETTING	(0x00100)
#define DX_D3D11_DRAWPREP_LIGHTING			(0x00200)
#define DX_D3D11_DRAWPREP_SPECULAR			(0x00400)
#define DX_D3D11_DRAWPREP_3D				(0x00800)
#define DX_D3D11_DRAWPREP_TEXADDRESS		(0x01000)
#define DX_D3D11_DRAWPREP_NOTSHADERRESET	(0x02000)
#define DX_D3D11_DRAWPREP_CULLING			(0x04000)
#define DX_D3D11_DRAWPREP_TEXTURE			(0x08000)
#define DX_D3D11_DRAWPREP_TEXALPHACH		(0x10000)
#define DX_D3D11_DRAWPREP_TEXALPHATEST		(0x20000)

// ftHgX^CU[Xe[g̃tB[h
#define DIRECT3D11_DEFAULTRS_FILLMODE_WIRE					(0)
#define DIRECT3D11_DEFAULTRS_FILLMODE_SOLID					(1)
#define DIRECT3D11_DEFAULTRS_FILLMODE_NUM					(2)

// ftHgXe[gp̔r[h`
#define DIRECT3D11_DEFAULT_CMP_NEVER						(0)				// FALSE
#define DIRECT3D11_DEFAULT_CMP_LESS							(1)				// Src <  Dest		DrawAlpha <  TestParam
#define DIRECT3D11_DEFAULT_CMP_EQUAL						(2)				// Src == Dest		DrawAlpha == TestParam
#define DIRECT3D11_DEFAULT_CMP_LESSEQUAL					(3)				// Src <= Dest		DrawAlpha <= TestParam
#define DIRECT3D11_DEFAULT_CMP_GREATER						(4)				// Src >  Dest		DrawAlpha >  TestParam
#define DIRECT3D11_DEFAULT_CMP_NOTEQUAL						(5)				// Src != Dest		DrawAlpha != TestParam
#define DIRECT3D11_DEFAULT_CMP_GREATEREQUAL					(6)				// Src >= Dest		DrawAlpha >= TestParam
#define DIRECT3D11_DEFAULT_CMP_ALWAYS						(7)				// TRUE
#define DIRECT3D11_DEFAULT_CMP_NUM							(8)

// sNZVF[_[̃At@eXg[h
#define DIRECT3D11_PS_ALPHATEST_CMP_GREATER					(0)				// `At@leXgAt@l傫Ε`
#define DIRECT3D11_PS_ALPHATEST_CMP_OTHER					(1)				// GREATER ȊO̔r[h
#define DIRECT3D11_PS_ALPHATEST_NUM							(2)

// W`撸_tH[}bg
#define D3D11_VERTEX_INPUTLAYOUT_NOTEX_2D		(0)				// ( VERTEX_NOTEX_2D                      \̌` )CA{bNX`p_tH[}bg
#define D3D11_VERTEX_INPUTLAYOUT_2D				(1)				// ( VERTEX2D or VERTEX_2D                \̌` )gXtH[ςݒ_tH[}bg
#define D3D11_VERTEX_INPUTLAYOUT_BLENDTEX_2D	(2)				// ( VERTEX_BLENDTEX_2D or VERTEX2DSHADER \̌` )uheNX`tgXtH[ςݒ_tH[}bg
#define D3D11_VERTEX_INPUTLAYOUT_NOTEX_3D		(3)				// ( VERTEX_NOTEX_3D                      \̌` )CA{bNX`p_tH[}bgARcp( o[Wp )
#define D3D11_VERTEX_INPUTLAYOUT_3D				(4)				// ( VERTEX_3D                            \̌` )OtBbNX`p_tH[}bgARcp( o[Wp )
#define D3D11_VERTEX_INPUTLAYOUT_3D_LIGHT		(5)				// ( VERTEX3D                             \̌` )OtBbNX`p_tH[}bg
#define D3D11_VERTEX_INPUTLAYOUT_SHADER_3D		(6)				// ( VERTEX3DSHADER                       \̌` )VF[_[`p_tH[}bg
#define D3D11_VERTEX_INPUTLAYOUT_NUM			(7)

// _obt@̃TCY
#define D3D11_VERTEXBUFFER_SIZE					(64 * 1024)

// e萔obt@̃ZbgWX^ԍ
#define DX_D3D11_VS_CONSTANTBUFFER_COMMON		(0)
#define DX_D3D11_VS_CONSTANTBUFFER_BASE			(1)
#define DX_D3D11_VS_CONSTANTBUFFER_OTHERMATRIX	(2)
#define DX_D3D11_VS_CONSTANTBUFFER_MATRIX		(3)

#define DX_D3D11_PS_CONSTANTBUFFER_COMMON		(0)
#define DX_D3D11_PS_CONSTANTBUFFER_BASE			(1)
#define DX_D3D11_PS_CONSTANTBUFFER_SHADOWMAP	(2)
#define DX_D3D11_PS_CONSTANTBUFFER_FILTER		(3)

// \̒` --------------------------------------------------------------------

// Direct3D11p n[hEGA_OpIWi摜eNX`
struct IMAGEDATA_ORIG_HARD_TEX_DIRECT3D11
{
	D_ID3D11Texture2D *				MSTexture ;								// }`TveNX`
	D_ID3D11Texture2D *				Texture ;								// eNX`
	D_ID3D11ShaderResourceView *	TextureSRV ;							// eNX`pVF[_[\[Xr[
//	D_ID3D11RenderTargetView *		TextureRTV[ CUBEMAP_SURFACE_NUM ] ;		// eNX`p_O^[Qbgr[
	D_ID3D11RenderTargetView **		TextureRTV ;							// eNX`p_O^[Qbgr[

	D_ID3D11Texture2D *				DepthBuffer ;							// [xobt@
	D_ID3D11DepthStencilView **		DepthBufferDSV ;						// [xobt@pfvXXeVr[
} ;

// Direct3D11p VhE}bv
struct SHADOWMAPDATA_DIRECT3D11
{
	D_ID3D11Texture2D *				DepthTexture ;							// [xlݗpeNX`
	D_ID3D11ShaderResourceView *	DepthTextureSRV ;						// [xlݗpeNX`pVF[_[\[Xr[
	D_ID3D11RenderTargetView *		DepthTextureRTV ;						// [xlݗpeNX`p_O^[Qbgr[

	D_ID3D11Texture2D *				DepthBuffer ;							// [xobt@
	D_ID3D11DepthStencilView *		DepthBufferDSV ;						// [xobt@pfvXXeVr[
} ;

// Direct3D11p _obt@nh
struct VERTEXBUFFERHANDLEDATA_DIRECT3D11
{
	D_ID3D11Buffer					*VertexBuffer ;							// ID3D11Buffer ̃|C^
} ;

// Direct3D11p CfbNXobt@nh
struct INDEXBUFFERHANDLEDATA_DIRECT3D11
{
	D_ID3D11Buffer					*IndexBuffer ;							// ID3D11Buffer ̃|C^
} ;

// Direct3D11p VF[_[nh
struct SHADERHANDLEDATA_DIRECT3D11
{
	union
	{
		D_ID3D11PixelShader			*PixelShader ;							// ID3D11PixelShader ̃|C^
		D_ID3D11VertexShader		*VertexShader ;							// ID3D11VertexShader ̃|C^
	} ;
} ;

// 萔obt@\
struct CONSTANTBUFFER_DIRECT3D11
{
	DWORD							Size ;									// TCY( oCgP )
	D_ID3D11Buffer *				ConstantBuffer ;						// ID3D11Buffer ̃|C^
	void *							SysmemBuffer ;							// 萔obt@ƓTCỸVXẽobt@
	int								ChangeFlag ;							// VXẽobt@ύXAID3DBuffer ւ̔fKvǂ( TRUE:Kv  FALSE:sv )

	CONSTANTBUFFER_DIRECT3D11 *		NextData ;								// Xg\̎̃f[^ւ̃|C^
	CONSTANTBUFFER_DIRECT3D11 *		PrevData ;								// Xg\̑Õf[^ւ̃|C^
} ;

// 萔obt@Ǘ\
struct CONSTANTBUFFER_DIRECT3D11_MANAGE
{
	int								BufferNum ;								// 萔obt@\̂̐
	CONSTANTBUFFER_DIRECT3D11 *		FirstBuffer ;							// ŏ̒萔obt@\̂ւ̃|C^
} ;

// Direct3D11p VF[_[p萔obt@nh
struct SHADERCONSTANTBUFFERHANDLEDATA_DIRECT3D11
{
	int								SetFlag ;								// VF[_[ɃZbgĂ邩ǂ
	CONSTANTBUFFER_DIRECT3D11 *		ConstBuffer ;							// 萔obt@
} ;

// Direct3D11 ̕W`p̃VF[_[Z߂\
struct GRAPHICS_HARDWARE_DIRECT3D11_SHADER_BASE
{
	// W`p̕GȏsȂ_VF[_[
	D_ID3D11VertexShader					*BaseSimple_VS[ D3D11_VERTEX_INPUTLAYOUT_NUM ] ;

	// Œ@\pCvC݊̃sNZVF[_[( eNX`Ȃ )
	// [ ( 0:ʏ`  1:Z`  2:RGB]  3:`PxS{  4:Zς݃uh[h̒ʏ`  5:Zς݃uh[hRGB]  6:Zς݃uh[h̕`Px4{ ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	D_ID3D11PixelShader						*BaseNoneTex_PS[ 7 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// Œ@\pCvC݊̃sNZVF[_[( eNX` )
	// [ uh摜Ƃ̃uh^Cv( 0:Ȃ  1:DX_BLENDGRAPHTYPE_NORMAL  2:DX_BLENDGRAPHTYPE_WIPE  3:DX_BLENDGRAPHTYPE_ALPHA ) ]
	// [ ( 0:ʏ`  1:Z`  2:RGB]  3:`PxS{  4:Zς݃uh[h̒ʏ`  5:Zς݃uh[hRGB]  6:Zς݃uh[h̕`Px4{ ) ]
	// [ eNX`RGB( 0:Ȃ  1: ) ]
	// [ eNX`Alpha( 0:Ȃ  1: ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	D_ID3D11PixelShader						*BaseUseTex_PS[ 4 ][ 7 ][ 2 ][ 2 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// }XNp̃sNZVF[_[
	D_ID3D11PixelShader						*MaskEffect_PS ;
	D_ID3D11PixelShader						*MaskEffect_ReverseEffect_PS ;
	D_ID3D11PixelShader						*MaskEffect_UseGraphHandle_PS[ 4 ] ;
	D_ID3D11PixelShader						*MaskEffect_UseGraphHandle_ReverseEffect_PS[ 4 ] ;

	// P]p֌W
	D_ID3D11SamplerState					*StretchRect_SamplerState[ 2 /* 0:Point  1:Linear */ ] ;
	D_ID3D11RasterizerState					*StretchRect_RasterizerState ;
	D_ID3D11DepthStencilState				*StretchRect_DepthStencilState ;
	D_ID3D11BlendState						*StretchRect_BlendState[ 2 /* 0:NoBlend  1:AlphaBlend */ ] ;
	D_ID3D11VertexShader					*StretchRect_VS ;
	D_ID3D11VertexShader					*StretchRectTex8_VS ;
	D_ID3D11PixelShader						*StretchRect_PS ;
} ;

// Direct3D11 ̕WRc`p̃VF[_[Z߂\
struct GRAPHICS_HARDWARE_DIRECT3D11_SHADER_BASE3D
{
	// WRc`psNZPʃCeBO^Cv̒_VF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// /* [ bV^Cv( 0:̃bV 1:4{[XLjObV 2:8{[XLjObV ) ] */
	// /* [ ov}bv̗L( 0: 1:L ) ] */
	// [ tHO^Cv ]
	D_ID3D11VertexShader					*Base3D_PixelLighting_VS[ 2 ]/*[ 3 ]*//*[ 2 ]*/[ 4 ] ;

	// WRc`psNZPʃCeBO^CṽsNZVF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// /*[ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]*/
	// /*[ XyL}bv ( 0: 1: ) ]*/
	// /*[ ov}bv ( 0:Ȃ 1: ) ]*/
	// [ CgCfbNX ]
	// /*[ XyL̗L( 0: 1:L ) ]*/
	// [ ( 0:ʏ`  1:Z`  2:RGB]  3:`PxS{  4:Zς݃uh[h̒ʏ`  5:Zς݃uh[hRGB]  6:Zς݃uh[h̕`Px4{ ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	D_ID3D11PixelShader						*Base3D_PixelLighting_Normal_PS[ 2 ]/*[ 5 ]*//*[ 2 ]*//*[ 2 ]*/[ 84 ]/*[ 2 ]*/[ 7 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;



	// WRc`p̃VhE}bvւ̃_Op_VF[_[
	// /*[ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]*/
	// [ ov}bv̗L( 0: 1:L ) ]
	D_ID3D11VertexShader					*Base3D_ShadowMap_VS/*[ 3 ]*/[ 2 ] ;

	// WRc`p̃CeBOȂ_VF[_[
	// /*[ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]*/
	// [ tHO^Cv ]
	D_ID3D11VertexShader					*Base3D_NoLighting_VS/*[ 3 ]*/[ 4 ] ;

	// WRc`p̒_PʃCeBO_VF[_[
	// [ VhE}bv̗L( 0: 1:L ) ]
	// /*[ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]*/
	// /*[ ov}bv̗L( 0: 1:L ) ]*/
	// [ tHO^Cv ]
	// [ CgCfbNX ]
	// /*[ XyL̗L( 0: 1:L ) ]*/
	D_ID3D11VertexShader					*Base3D_VertexLighting_VS[ 2 ]/*[ 3 ]*//*[ 2 ]*/[ 4 ][ 20 ]/*[ 2 ]*/ ;

	// WRc`p̃VhE}bvւ̃_OpsNZVF[_[
	// [ sNZVF[_[̃At@eXg[h ]
	D_ID3D11PixelShader						*Base3D_ShadowMap_Normal_PS[ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// WRc`p̃CeBOȂsNZVF[_[
	// /*[ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]*/
	// [ ( 0:ʏ`  1:Z`  2:RGB]  3:`PxS{  4:Zς݃uh[h̒ʏ`  5:Zς݃uh[hRGB]  6:Zς݃uh[h̕`Px4{ ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	D_ID3D11PixelShader						*Base3D_NoLighting_Normal_PS/*[ 5 ]*/[ 7 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// WRc`p̒_PʃCeBOsNZVF[_[
	// [ VhE}bv̗L( 0: 1:L ) ]
	// /* [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ] */
	// /* [ XyL}bv ( 0: 1: ) ] */
	// /* [ ov}bv ( 0:Ȃ 1: ) ] */
	// [ CgCfbNX ]
	// /*[ XyL̗L( 0: 1:L ) ]*/
	// [ ( 0:ʏ`  1:Z`  2:RGB]  3:`PxS{  4:Zς݃uh[h̒ʏ`  5:Zς݃uh[hRGB]  6:Zς݃uh[h̕`Px4{ ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	D_ID3D11PixelShader						*Base3D_VertexLighting_Normal_PS[ 2 ]/*[ 5 ]*//*[ 2 ]*//*[ 2 ]*/[ 10 ]/*[ 2 ]*/[ 7 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;
} ;


#ifndef DX_NON_MODEL

// Direct3D11 ̃f`p̃VF[_[Z߂\
struct GRAPHICS_HARDWARE_DIRECT3D11_SHADER_MODEL
{
	// f`psNZPʃCeBO^Cv̒_VF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV 2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	// [ tHO^Cv ]
	D_ID3D11VertexShader					*MV1_PixelLighting_VS[ 2 ][ 3 ][ 2 ][ 4 ] ;

	// f`psNZPʃCeBO^CṽgD[^CvPpsNZVF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// [ gD[_ÕXyLOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ LȃCg̐ - 1 ]
	// [ sNZVF[_[̃At@eXg[h ]
	D_ID3D11PixelShader						*MV1_PixelLighting_ToonType1_PS[ 2 ][ 2 ][ 2 ][ 2 ][ DX_D3D11_COMMON_CONST_LIGHT_NUM ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// f`psNZPʃCeBO^CṽgD[^CvQpsNZVF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ gD[_ÕXtBA}bv̗Lƃuh^Cv( 0:XtBA}bv͖   1:MV1_LAYERBLEND_TYPE_MODULATE  2:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ LȃCg̐ - 1 ]
	// [ sNZVF[_[̃At@eXg[h ]
	D_ID3D11PixelShader						*MV1_PixelLighting_ToonType2_PS[ 2 ][ 3 ][ DX_D3D11_COMMON_CONST_LIGHT_NUM ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// f`psNZPʃCeBO^CṽsNZVF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ LȃCg̐ - 1 ]
	// [ sNZVF[_[̃At@eXg[h ]
	D_ID3D11PixelShader						*MV1_PixelLighting_Normal_PS[ 2 ][ 5 ][ 2 ][ DX_D3D11_COMMON_CONST_LIGHT_NUM ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;





	// f`p̃VhE}bvւ̃gD[_O֊s`p_VF[_[
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	D_ID3D11VertexShader					*MV1_ToonOutLine_ShadowMap_VS[ 3 ][ 2 ] ;

	// f`p̃gD[_O̗֊s`p_VF[_[
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	// [ tHO^Cv ]
	D_ID3D11VertexShader					*MV1_ToonOutLine_VS[ 3 ][ 2 ][ 4 ] ;

	// f`p̃VhE}bvւ̃_Op_VF[_[
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	D_ID3D11VertexShader					*MV1_ShadowMap_VS[ 3 ][ 2 ] ;

	// f`p̃CeBOȂ_VF[_[
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	// [ tHO^Cv ]
	D_ID3D11VertexShader					*MV1_NoLighting_VS[ 3 ][ 2 ][ 4 ] ;

	// f`p̒_PʃCeBO蒸_VF[_[
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	// [ tHO^Cv ]
	// [ CgCfbNX ]
	D_ID3D11VertexShader					*MV1_VertexLighting_VS[ 2 ][ 3 ][ 2 ][ 4 ][ 20 ] ;

	// f`p̃VhE}bvւ̃gD[_OpsNZVF[_[
	// [ gD[_O^Cv( 0:gD[_O type 1   1:gD[_O type 2 ) ]
	// [ gD[_ÕXtBA}bv̗Lƃuh^Cv( 0:XtBA}bv͖   1:MV1_LAYERBLEND_TYPE_MODULATE  2:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	D_ID3D11PixelShader						*MV1_ShadowMap_Toon_PS[ 2 ][ 3 ][ 2 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// f`p̃VhE}bvւ̃_OpsNZVF[_[
	// [ sNZVF[_[̃At@eXg[h ]
	D_ID3D11PixelShader						*MV1_ShadowMap_Normal_PS[ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// f`p̃CeBOȂgD[psNZVF[_[( Xg͔z̍ )
	// [ gD[_O^Cv( 0:gD[_O type 1   1:gD[_O type 2 ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT or gD[_Oł͂Ȃ  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	D_ID3D11PixelShader						*MV1_NoLighting_Toon_PS[ 2 ][ 2 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// f`p̃CeBOȂsNZVF[_[
	// [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	D_ID3D11PixelShader						*MV1_NoLighting_Normal_PS[ 5 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// f`p̒_PʃCeBOgD[^CvPpsNZVF[_[
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// [ gD[_ÕXyLOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ CgCfbNX ]
	// [ sNZVF[_[̃At@eXg[h ]
	D_ID3D11PixelShader						*MV1_VertexLighting_ToonType1_PS[ 2 ][ 2 ][ 2 ][ 2 ][ 10 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// f`p̒_PʃCeBOgD[^CvQpsNZVF[_[
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ gD[_ÕXtBA}bv̗Lƃuh^Cv( 0:XtBA}bv͖   1:MV1_LAYERBLEND_TYPE_MODULATE  2:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ CgCfbNX ]
	// [ sNZVF[_[̃At@eXg[h ]
	D_ID3D11PixelShader						*MV1_VertexLighting_ToonType2_PS[ 2 ][ 3 ][ 10 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// f`p̒_PʃCeBOsNZVF[_[
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ CgCfbNX ]
	// [ sNZVF[_[̃At@eXg[h ]
	D_ID3D11PixelShader						*MV1_VertexLighting_Normal_PS[ 2 ][ 5 ][ 2 ][ 10 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;
} ;
#endif // DX_NON_MODEL

// Direct3D11 ̒萔Z߂\
struct GRAPHICS_HARDWARE_DIRECT3D11_CONSTANT
{
	CONSTANTBUFFER_DIRECT3D11_MANAGE			ConstantBufferManage ;			// 萔obt@

	CONSTANTBUFFER_DIRECT3D11 *					ConstBuffer_Common ;			// _VF[_[sNZVF[_[ʂ̃p[^p萔obt@( DX_D3D11_CONST_BUFFER_COMMON \ )
	int											SetNormalMaterial ;				// 萔obt@ɕW`p̃}eAp[^ݒ肳Ă邩ǂ( TRUE:ݒ肳Ă  FALSE:ݒ肳ĂȂ )

	CONSTANTBUFFER_DIRECT3D11 *					ConstBuffer_VS_Base ;			// _VF[_[{p[^p萔obt@( DX_D3D11_VS_CONST_BUFFER_BASE \ )
	int											SetNormalColorSource ;			// 萔obt@ɕW`ṕufBt[YJ[EXyLJ[}eAgp邩A_f[^gp邩v̐ݒ肪Ă邩ǂ( TRUE:ݒ肳Ă  FALSE:ݒ肳ĂȂ )

	CONSTANTBUFFER_DIRECT3D11 *					ConstBuffer_VS_OtherMatrix ;	// _VF[_[̑sp[^p萔obt@( DX_D3D11_VS_CONST_BUFFER_OTHERMATRIX \ )
	int											SetNormalTextureAddressTransformMatrix ;	// 萔obt@ɕW`p̃eNX`Wps񂪐ݒ肳Ă邩ǂ( TRUE:ݒ肳Ă  FALSE:ݒ肳ĂȂ )

	CONSTANTBUFFER_DIRECT3D11 *					ConstBuffer_VS_LocalWorldMatrix ;	// _VF[_[XLjObVṕ@[J@@[hsp[^p萔obt@( DX_D3D11_VS_CONST_BUFFER_LOCALWORLDMATRIX \ )

	CONSTANTBUFFER_DIRECT3D11 *					ConstBuffer_PS_Base ;			// sNZVF[_[{p[^p萔obt@( DX_D3D11_PS_CONST_BUFFER_BASE \ )
	CONSTANTBUFFER_DIRECT3D11 *					ConstBuffer_PS_ShadowMap ;		// sNZVF[_[VhE}bvp萔obt@( DX_D3D11_PS_CONST_BUFFER_SHADOWMAP \ )
	CONSTANTBUFFER_DIRECT3D11 *					ConstBuffer_PS_Filter ;			// sNZVF[_[tB^[p萔obt@
} ;

// Direct3D11 ̃VF[_[Z߂\
struct GRAPHICS_HARDWARE_DIRECT3D11_SHADER
{
	GRAPHICS_HARDWARE_DIRECT3D11_CONSTANT		Constant ;						// 萔Z߂\

	GRAPHICS_HARDWARE_DIRECT3D11_SHADER_BASE	Base ;							// W`揈p̃VF[_[Z߂\
	GRAPHICS_HARDWARE_DIRECT3D11_SHADER_BASE3D	Base3D ;						// WRc`揈p̃VF[_[Z߂\

#ifndef DX_NON_MODEL
	GRAPHICS_HARDWARE_DIRECT3D11_SHADER_MODEL	Model ;							// f`揈p̃VF[_[Z߂\
#endif // DX_NON_MODEL
} ;



// Direct3D11 ̓̓CAEgZ߂\
struct GRAPHICS_HARDWARE_DIRECT3D11_INPUTLAYOUT
{
	// W`p̒_VF[_[Ŏgp钸_f[^tH[}bg
	D_ID3D11InputLayout *						BaseInputLayout[ D3D11_VERTEX_INPUTLAYOUT_NUM ] ;

	// P]p̒_VF[_[Ŏgp钸_f[^tH[}bg
	D_ID3D11InputLayout *						BaseStretchRectInputLayout ;
	D_ID3D11InputLayout *						BaseStretchRectTex8InputLayout ;

#ifndef DX_NON_MODEL
	// ̓CAEg( Xg͔z̍ )
	// [ ov}bvtǂ( 1:ov}bvt 0:tĂȂ ) ]
	// [ XLjObVǂ( 0:̃bV 1:4{[XLjObV 2:8{[XLjObV ) ]
	D_ID3D11InputLayout *						MV1_VertexInputLayout[ 2 ][ 3 ] ;
#endif // DX_NON_MODEL
} ;






// D3D11Device ɐݒ肵ĂlZ߂\
struct GRAPHICS_HARDDATA_DIRECT3D11_DEVICE_STATE
{
	int										FogEnable ;										// tHOLǂ( TRUE:L  FALSE: )
	int										FogMode ;										// tHO[h
	DWORD									FogColor ;										// tHOJ[
	float									FogStart ;										// tHOJn
	float									FogEnd ;										// tHOI
	float									FogDensity ;									// tHOx

	COLOR_F									GlobalAmbientLightColor ;						// O[oArGgCgJ[
	int										LightEnableMaxIndex ;							// LȃCg̍őCfbNX
	int										LightEnableFlag[ DX_D3D11_COMMON_CONST_LIGHT_NUM ] ;// CgLǂtO( TRUE:L  FALSE: )
	LIGHTPARAM								LightParam[ DX_D3D11_COMMON_CONST_LIGHT_NUM ] ;	// Cg̃p[^
	int										Lighting ;										// CeBOsǂ̃tO( TRUE:CeBOs  FALSE:CeBOȂ )

	int										UseSpecular ;									// XyLgp邩ǂ
	MATERIALPARAM							Material ;										// }eA
	int										MaterialUseVertexDiffuseColor ;					// _̃fBt[YJ[}eÃfBt[YJ[ƂĎgp邩ǂ
	int										MaterialUseVertexSpecularColor ;				// _̃XyLJ[}eÃXyLJ[ƂĎgp邩ǂ

	int										DrawMode ;										// `惂[h( DX_DRAWMODE_BILINEAR Ȃ )AW̃tB^O[hł͂Ȃꍇ -1
	int										MaxAnisotropy ;									// őٕASẴTvɑ΂ēݒ肪sĂȂꍇ -1
	int										ChangeSamplerDesc ;								// foCX̃Tv[Xe[g̐ݒɕύXǂ( TRUE:ύX  FALSE:ύX͂Ȃ )
	int										ChangeSamplerDescSlot[ USE_TEXTURESTAGE_NUM ] ;	// foCX̊eXbg̃Tv[Xe[g̐ݒɕύXǂ( TRUE:ύX  FALSE:ύX͂Ȃ )
	D_D3D11_SAMPLER_DESC					SamplerDesc[ USE_TEXTURESTAGE_NUM ] ;			// foCX̊eXbg̃Tv[Xe[g̐ݒl
	D_ID3D11SamplerState *					SamplerState[ USE_TEXTURESTAGE_NUM ] ;			// ݃foCX̊eXbgɐݒ肳ĂTv[Xe[g
	int										ChangeSamplerStateReleaseFlag[ USE_TEXTURESTAGE_NUM ] ;					// ݃foCX̊eXbgɐݒ肳ĂTv[Xe[gύXۂɃ[X邩ǂ̃tO( TRUE:[X  FALSE:[XȂ )
	D_ID3D11SamplerState *					DefaultSamplerStateArray[ DIRECT3D11_DEFAULTRS_FILTER_NUM ][ D_D3D11_TEXTURE_ADDRESS_MIRROR_ONCE + 1 ][ D_D3D11_TEXTURE_ADDRESS_MIRROR_ONCE + 1 ][ D_D3D11_TEXTURE_ADDRESS_MIRROR_ONCE + 1 ][ 2 /* MaxAnisotropy  vfԍ0 = 1  vfԍ1 = 16 */ ] ;	// 悭gݒ̃Tv[Xe[g̔z

	D_D3D11_VIEWPORT						Viewport ;										// r[|[g

	int										ChangeRasterizerDesc ;							// foCX̃X^CU[Xe[g̐ݒɕύXǂ( TRUE:ύX  FALSE:ύX͂Ȃ )
	D_D3D11_RASTERIZER_DESC					RasterizerDesc ;								// ݃foCXɐݒ肳Ă郉X^CU[Xe[g̐ݒl
	D_ID3D11RasterizerState *				RasterizerState ;								// ݃foCXɐݒ肳Ă郉X^CU[Xe[g
	int										ChangeRasterizerStateReleaseFlag ;				// ݃foCXɐݒ肳Ă郉X^CU[Xe[gύXۂɃ[X邩ǂ̃tO( TRUE:[X  FALSE:[XȂ )
	D_ID3D11RasterizerState *				DefaultRasterizerStateArray[ D_D3D11_CULL_BACK + 1 ][ D_D3D11_FILL_SOLID + 1 ][ 2 /* [xeXg̗L */ ][ 2 /* }`Tv̗L */ ] ;	// 悭gݒ̃X^CU[Xe[g̔z

	int										ChangeDepthStencilDesc ;						// foCX̐[xXeVXe[g̐ݒɕύXǂ( TRUE:ύX  FALSE:ύX͂Ȃ )
	D_D3D11_DEPTH_STENCIL_DESC				DepthStencilDesc ;								// ݃foCXɐݒ肳Ă[xXeVeXgXe[g̐ݒl
	D_ID3D11DepthStencilState *				DepthStencilState ;								// ݃foCXɐݒ肳Ă[xXeVXe[g
	int										ChangeDepthStencilStateReleaseFlag ;			// ݃foCXɐݒ肳Ă[xXeVXe[gύXۂɃ[X邩ǂ̃tO( TRUE:[X  FALSE:[XȂ )
	D_ID3D11DepthStencilState *				DefaultDepthStencilStateArray[ 2 /* [xeXg̗L */ ][ 2 /* [xobt@ւ݂̗̏L */ ][ D_D3D11_COMPARISON_ALWAYS + 1 ] ;	// 悭gݒ̐[xXeVXe[g̔z

	int										BlendMode ;										// ݃foCXɐݒ肳Ăuh[hAvZbg̃uh[hȊȌꍇ -1 
	int										ChangeBlendDesc ;								// foCX̃ufBOXe[g̐ݒɕύXǂ( TRUE:ύX  FALSE:ύX͂Ȃ )
	D_D3D11_BLEND_DESC						BlendDesc ;										// ݃foCXɐݒ肳ĂufBOXe[g̐ݒl
	D_ID3D11BlendState *					BlendState ;									// ݃foCXɐݒ肳ĂufBOXe[g
	int										ChangeBlendStateReleaseFlag ;					// ݃foCXɐݒ肳ĂufBOXe[gύXۂɃ[X邩ǂ̃tO( TRUE:[X  FALSE:[XȂ )
	D_ID3D11BlendState *					DefaultBlendStateArray[ DX_BLENDMODE_NUM ] ;	// 悭gݒ̃ufBOXe[g̔z

	D_ID3D11ShaderResourceView *			PSSetShaderResourceView[ D_D3D11_COMMONSHADER_INPUT_RESOURCE_SLOT_COUNT ] ;		// ݃foCXɐݒ肳ĂsNZVF[_[\[Xr[

	RECT									ScissorRect ;									// VU[`
	int										AlphaTestEnable ;								// At@eXggp邩ǂ
	int										AlphaTestCmpMode ;								// At@eXgŎgpr[h( DX_CMP_NEVER Ȃ )
	int										AlphaTestRef ;									// At@eXgŎgpQƒl
	int										AlphaTestModeShaderIndex ;						// At@eXg̐ݒlɑΉsNZVF[_[̃At@eXg[h( DIRECT3D11_PS_ALPHATEST_CMP_GREATER Ȃ )

	D_D3D11_PRIMITIVE_TOPOLOGY				PrimitiveTopology ;								// foCXɐݒ肳Ăv~eBu^Cv

	D_ID3D11Buffer *						SetPixelShaderConstantBuffer[  D_D3D11_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT ] ;	//  ID3D11DeviceContext ɃsNZVF[_[pɃZbgĂ萔obt@
	D_ID3D11Buffer *						SetVertexShaderConstantBuffer[ D_D3D11_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT ] ;	//  ID3D11DeviceContext ɒ_VF[_[pɃZbgĂ萔obt@

	int										SetNormalPixelShader ;							// ʏ`psNZVF[_[ZbgĂ邩ǂ
	D_ID3D11PixelShader *					SetPixelShader ;								//  ID3D11DeviceContext ɃZbgĂsNZVF[_[

	int										SetNormalVertexShader ;							// ʏ`p_VF[_[ZbgĂ邩ǂ
	D_ID3D11VertexShader *					SetVertexShader ;								//  ID3D11DeviceContext ɃZbgĂ钸_VF[_[

	D_ID3D11Buffer *						SetIndexBuffer ;								//  ID3D11DeviceContext ɃZbgĂCfbNXobt@
	D_DXGI_FORMAT							SetIndexBufferFormat ;							//  ID3D11DeviceContext ɃZbgĂCfbNXobt@̃tH[}bg

	D_ID3D11InputLayout *					SetVertexInputLayout ;							//  ID3D11DeviceContext ɃZbgĂ̓CAEg

	D_ID3D11Buffer *						SetVertexBuffer ;								//  ID3D11DeviceContext ɃZbgĂ钸_obt@
	int										SetVertexBufferStride ;							//  ID3D11DeviceContext ɃZbgĂ钸_obt@̃XgCh

	D_ID3D11Texture2D *						TargetTexture2D[ DX_RENDERTARGET_COUNT ] ;		// `Ώۂ̃eNX`
	D_D3D11_TEXTURE2D_DESC					TargetTexture2DDesc[ DX_RENDERTARGET_COUNT ] ;	// `Ώۂ̃eNX`̏
	D_ID3D11RenderTargetView *				TargetRTV[ DX_RENDERTARGET_COUNT ] ;			// `Ώۂ̃_O^[Qbgr[

	D_ID3D11Texture2D *						TargetDepthTexture2D ;							// `Ώۂ̐[xeNX`
	D_D3D11_TEXTURE2D_DESC					TargetDepthTexture2DDesc ;						// `Ώۂ̐[xeNX`̏
	D_ID3D11DepthStencilView *				TargetDepthDSV ;								// `Ώۂ̐[xXeVr[

	int										TextureAddressTransformMatrixUse ;				// eNX`Wϊsgp邩ǂ( TRUE:gp  FALSE:gpȂ )
	MATRIX									TextureAddressTransformMatrix ;					// eNX`Wϊs
} ;


// D3D11Device ̕`揈Ɋւ̍\
struct GRAPHICS_HARDDATA_DIRECT3D11_DRAWINFO
{
	BYTE						VertexBufferTemp[ D3D11_VERTEXBUFFER_SIZE ] ;	// VXe̒_obt@
	BYTE *						VertexBufferAddr ;								// VXe̒_obt@
	BYTE *						VertexBufferNextAddr ;							// ̃f[^i[ׂ_obt@̃AhX
	D_ID3D11Buffer *			VertexBuffer ;									// `p ID3D11Buffer
	int							VertexNum ; 									// _obt@Ɋi[Ă钸_̐
	int							Use3DVertex ;									// Rc_gpĂ邩ǂ( 1:gpĂ  0:gpĂȂ )
	int							VertexType ;									// gp钸_^Cv( VERTEXTYPE_TEX  )
	D_D3D11_PRIMITIVE_TOPOLOGY	PrimitiveType ;									// _obt@Ɋi[Ă钸_f[^̃v~eBu^Cv

	DWORD						DiffuseColor ;									// fBt[YJ[

	int							BeginSceneFlag ;								// Graphics_D3D11_BeginScene sĂ邩ǂ
	int							BlendMaxNotDrawFlag ;							// uhlőł邱Ƃɂ`sȂǂAtO

	D_ID3D11Buffer *			CommonVertexBuffer ;							// ėp`p_obt@
	int							CommonVertexBufferSize ;						// ėp`p_obt@̃TCY
	D_ID3D11Buffer *			CommonIndexBuffer ;								// ėp`pCfbNXobt@
	int							CommonIndexBufferSize ;							// ėp`pCfbNXobt@̃TCY
} ;

// D3D11Device ̏o͐EChE̏̍\
struct GRAPHICS_HARDDATA_DIRECT3D11_OUTPUTWINDOWINFO
{
	int								UseFlag ;								// zgpĂ邩( TRUE:gpĂ  FALSE:gpĂȂ )

	D_IDXGISwapChain *				DXGISwapChain ;							// DXGISwapChain
	D_DXGI_SWAP_CHAIN_DESC			DXGISwapChainDesc ;						// DXGISwapChain
	D_IDXGIOutput *					DXGIOutput ;							// DXGIOutput

	D_ID3D11Texture2D *				BufferTexture2D ;						// Xbv`FC̃obNobt@eNX`
	D_D3D11_TEXTURE2D_DESC			BufferTexture2DDesc ;					// Xbv`FC̃obNobt@eNX`
	D_ID3D11ShaderResourceView *	BufferSRV ;								// Xbv`FC̃obNobt@VF[_[\[Xr[
	D_ID3D11RenderTargetView *		BufferRTV ;								// Xbv`FC̃obNobt@_[^[Qbgr[
} ;


// D3D11Device ̉ʊ֌W̏̍\
struct GRAPHICS_HARDDATA_DIRECT3D11_SCREENINFO
{
	int												OutputWindowNum ;									// o͐EChE̐
	GRAPHICS_HARDDATA_DIRECT3D11_OUTPUTWINDOWINFO	OutputWindowInfo[ DX_D3D11_MAX_OUTPUTWINDOW ] ;		// o͐EChȄ
	int												TargetOutputWindow ;								// ݂̏o͐EChE̔ԍ
	int												FullscreenSatte ;									// tXN[[hɂĂ邩( TRUE:Ă  FALSE:ĂȂ )
//	D_ID3D11Texture2D *				BackBufferTexture2D ;
//	D_ID3D11ShaderResourceView *	BackBufferSRV ;
//	D_ID3D11RenderTargetView *		BackBufferRTV ;
//	D_D3D11_TEXTURE2D_DESC			BackBufferTexture2DDesc ;

	int								SubBackBufferTextureSizeX ;				// TuobNobt@eNX`̉
	int								SubBackBufferTextureSizeY ;				// TuobNobt@eNX`̏c
	D_ID3D11Texture2D *				SubBackBufferTexture2D ;				// ScreenCopy  GetDrawScreen 邽߂Ɏgp`\eNX`
	D_ID3D11RenderTargetView *		SubBackBufferRTV ;						// ScreenCopy  GetDrawScreen 邽߂Ɏgp`\eNX`p̃_[^[Qbgr[
	D_ID3D11ShaderResourceView *	SubBackBufferSRV ;						// ScreenCopy  GetDrawScreen 邽߂Ɏgp`\eNX`p̃VF[_[\[Xr[

	D_ID3D11Texture2D *				DepthBufferTexture2D ;
	D_ID3D11DepthStencilView *		DepthBufferDSV ;
//	D_ID3D11ShaderResourceView *	DepthBufferSRV ;
	int								DepthBufferSizeX ;						// [xobt@T[tFX̕
	int								DepthBufferSizeY ;						// [xobt@T[tFX̍
	int								DepthBufferBitDepth ;					// [xobt@T[tFX̃rbg[x

	D_ID3D11Texture2D *				DrawScreenBufferLockSMTexture ;			// `Ώۃobt@bNۂɎgpeNX`̃|C^
} ;


// D3D11Device ̕`ݒɊւ̍\
struct GRAPHICS_HARDDATA_DIRECT3D11_DRAWSETTING
{
	int								DrawPrepParamFlag ;						// O Graphics_D3D11_DrawPreparation ɓƂ ParamFlag p[^
	int								DrawPrepAlwaysFlag ;					// K Graphics_D3D11_DrawPreparation sǂ̃tO

	int								AlphaChannelValidFlag ;					// `lLtO
	int								AlphaTestValidFlag ;					// eXgLtO( Func ͕K D_D3DCMP_GREATEREQUAL )
	int								AlphaTestMode ;							// At@eXg[h
	int								AlphaTestParam ;						// At@eXgp[^
	int								BlendMode ;								// uh[h
	int								ChangeBlendParamFlag ;					// uhݒɊւ镔̕ύXAtO
	int								ChangeTextureFlag ;						// eNX`ύXꂽAtO
	int								IgnoreGraphColorFlag ;					// `悷摜̐F𖳎邩ǂ̃tO
//	int								UseDiffuseRGBColor ;					// fBt[YJ[̂qfalgp邩AtO
//	int								UseDiffuseAlphaColor ;					// fBt[YJ[̃lgp邩AtO
	int								BlendGraphType ;						// uh摜^Cv
	int								BlendGraphFadeRatio ;					// uh摜̃tF[hp[^
	int								BlendGraphBorderParam ;					// uh摜̋Ep[^(O(uh摜̉eO)@@(uh摜̉eȂ)@@PQW(uh摜̉ePOO)@@(uh摜̉e𒴂Ĕ`敔)@QTT(S`悳Ȃ) )
	int								BlendGraphBorderRange ;					// uh摜̋E(O`QTT@`L@SiK)
	float							BlendTextureWidth ;						// uheNX`̕
	float							BlendTextureHeight ;					// uheNX`̍
	float							InvBlendTextureWidth ;					// uheNX`̋̕t
	float							InvBlendTextureHeight ;					// uheNX`̍̋t

	D_ID3D11Texture2D *				RenderTexture ;							// `掞ɎgpeNX`[
	D_ID3D11ShaderResourceView *	RenderTextureSRV ;						// `掞ɎgpeNX`[̃VF[_[\[Xr[
	D_ID3D11Texture2D *				BlendTexture ;							// `掞ɕ`eNX`[ƃuh郿`leNX`[
	D_ID3D11ShaderResourceView *	BlendTextureSRV ;						// `掞ɕ`eNX`[ƃuh郿`leNX`[̃VF[_[\[Xr[

	int								CancelSettingEqualCheck ;				// ̃tOĂꍇ݂͌̐ݒƕύX̐ݒ肪ǂɊւ炸AKύXs
} ;


// D3D11Device ֌W̐ݒ̍\
struct GRAPHICS_HARDDATA_DIRECT3D11_DEVICE_SETTING
{
	void					( *DeviceRestoreCallbackFunction)( void *Data ) ;	// foCXXg畜AƂɌĂԊ֐
	void					  *DeviceRestoreCallbackData ;						// foCXXg畜AƂɌĂԊ֐ɓn|C^

	void					( *DeviceLostCallbackFunction)( void *Data ) ;		// foCXXg畜AOɌĂԊ֐
	void					  *DeviceLostCallbackData ;							// foCXXg畜AOɌĂԊ֐ɓn|C^
} ;


// D3D11Device ̔\͏\
struct GRAPHICS_HARDDATA_DIRECT3D11_DEVICE_CAPS
{
	D_DXGI_FORMAT					ScreenFormat ;										// ʃJ[tH[}bg
	D_DXGI_FORMAT					TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_NUM ] ;	// eNX`tH[}bg
	D_DXGI_FORMAT					MaskColorFormat ;									// }XNJ[obt@ptH[}bg
	D_DXGI_FORMAT					MaskAlphaFormat ;									// }XNAt@`lptH[}bg
	D_DXGI_FORMAT					DepthBufferTexture2DFormat[ ZBUFFER_FORMAT_NUM ] ;		// [xobt@pTexture2DtH[}bg
	D_DXGI_FORMAT					DepthBufferDepthStencilFormat[ ZBUFFER_FORMAT_NUM ] ;	// [xobt@pDepthStenciltH[}bg
} ;


// Direct3D11 g`揈Ŏgpf[^̓ D3D11Device ̃Zbg
// KvAD3D11Device ɖڂɊւZ߂\
struct GRAPHICS_HARDDATA_DIRECT3D11_DEVICE
{
	GRAPHICS_HARDDATA_DIRECT3D11_DEVICE_CAPS		Caps ;					// foCX\͏\		

	GRAPHICS_HARDDATA_DIRECT3D11_DEVICE_SETTING		Setting ;				// foCX֌W̐ݒZ߂\

	GRAPHICS_HARDDATA_DIRECT3D11_SCREENINFO			Screen ;				// ʊ֌W̏\

	GRAPHICS_HARDWARE_DIRECT3D11_SHADER				Shader ;				// VF[_[Z߂\

	GRAPHICS_HARDWARE_DIRECT3D11_INPUTLAYOUT		InputLayout ;			// ̓CAEgZ߂\

	GRAPHICS_HARDDATA_DIRECT3D11_DRAWSETTING		DrawSetting ;			// `ݒɊւZ߂\

	GRAPHICS_HARDDATA_DIRECT3D11_DRAWINFO			DrawInfo ;				// `揈ɊւZ߂\

	GRAPHICS_HARDDATA_DIRECT3D11_DEVICE_STATE		State ;					// D3D11Device ɐݒ肵ĂlZ߂\
} ;













// VF[_[R[h̏\
struct GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO
{
	void					*Binary ;								// VF[_[R[hoCĩAhX
	int						Size ;									// VF[_[R[hoCĩf[^TCY
} ;


// Direct3D11  W`p̃VF[_[R[ȟf[^Z߂\
struct GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_BASE
{
	int						BaseShaderInitializeFlag ;				// VF[_[oCĩZbgAbvĂ邩ǂ̃tO( TRUE:Ă  FALSE:ĂȂ )

	// CgCfbNXXg
	short					LightIndexList84[ 4 ][ 4 ][ 4 ][ 4 ][ 4 ][ 4 ] ;
	short					LightIndexList20[ 4 ][ 4 ][ 4 ] ;
	short					LightIndexList10[ 3 ][ 3 ][ 3 ] ;

	void					*Base2DShaderPackageImage ;				// WQc`pVF[_[pbP[WoCiC[W

	// W`p̕GȏsȂ_VF[_[
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO BaseSimple_VS_Code[ D3D11_VERTEX_INPUTLAYOUT_NUM ] ;

	// Œ@\pCvC݊̃sNZVF[_[( eNX`Ȃ )
	// [ ( 0:ʏ`  1:Z`  2:RGB]  3:`PxS{  4:Zς݃uh[h̒ʏ`  5:Zς݃uh[hRGB]  6:Zς݃uh[h̕`Px4{ ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO BaseNoneTex_PS_Code[ 7 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// Œ@\pCvC݊̃sNZVF[_[( eNX` )
	// [ uh摜Ƃ̃uh^Cv( 0:Ȃ  1:DX_BLENDGRAPHTYPE_NORMAL  2:DX_BLENDGRAPHTYPE_WIPE  3:DX_BLENDGRAPHTYPE_ALPHA ) ]
	// [ ( 0:ʏ`  1:Z`  2:RGB]  3:`PxS{  4:Zς݃uh[h̒ʏ`  5:Zς݃uh[hRGB]  6:Zς݃uh[h̕`Px4{ ) ]
	// [ eNX`RGB( 0:Ȃ  1: ) ]
	// [ eNX`Alpha( 0:Ȃ  1: ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO BaseUseTex_PS_Code[ 4 ][ 7 ][ 2 ][ 2 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// }XNp̃sNZVF[_[
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MaskEffect_PS_Code ;
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MaskEffect_ReverseEffect_PS_Code ;
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MaskEffect_UseGraphHandle_PS_Code[ 4 ] ;
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MaskEffect_UseGraphHandle_ReverseEffect_PS_Code[ 4 ] ;

	// P]pVF[_[
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO StretchRect_VS_Code ;
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO StretchRectTex8_VS_Code ;
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO StretchRect_PS_Code ;

//	DXARC					BaseShaderBinDxa ;						// W`pVF[_[IuWFNgt@Ccw`\
//	void					*BaseShaderBinDxaImage ;				// W`pVF[_[IuWFNgt@Ccw`̃oCiC[W

#ifndef DX_NON_FILTER
	DXARC					FilterShaderBinDxa ;					// tB^[VF[_[IuWFNgt@Ccw`\
	void					*FilterShaderBinDxaImage ;				// tB^[VF[_[IuWFNgt@Ccw`̃oCiC[W

	void					*RGBAMixS_ShaderPackImage ;				// RGBAMix  S ̑gݍ킹QTU̃VF[_[pbP[WoCiC[W

	// RGBAMix  S ̑gݍ킹QTU̃VF[_[[ R ][ G ][ B ][ A ][ 0:ʏp  1:Zς݃At@p ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO RGBAMixS_PS_Code[ 4 ][ 4 ][ 4 ][ 4 ][ 2 ] ;
#endif // DX_NON_FILTER
} ;

// Direct3D11  WRc`p̃VF[_[R[ȟf[^Z߂\
struct GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_BASE3D
{
	volatile int			Base3DShaderInitializeFlag ;			// VF[_[oCĩZbgAbvĂ邩ǂ̃tO( TRUE:Ă  FALSE:ĂȂ )

	void					*Base3DShaderPackageImage ;				// WRc`pVF[_[pbP[WoCiC[W

	// WRc`psNZPʃCeBO^Cv̒_VF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// /* [ bV^Cv( 0:̃bV 1:4{[XLjObV 2:8{[XLjObV ) ] */
	// /* [ ov}bv̗L( 0: 1:L ) ] */
	// [ tHO^Cv ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO Base3D_PixelLighting_VS_Code[ 2 ]/*[ 3 ]*//*[ 2 ]*/[ 4 ] ;

	// WRc`psNZPʃCeBO^CṽsNZVF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// /*[ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]*/
	// /*[ XyL}bv ( 0: 1: ) ]*/
	// /*[ ov}bv ( 0:Ȃ 1: ) ]*/
	// [ CgCfbNX ]
	// /*[ XyL̗L( 0: 1:L ) ]*/
	// [ ( 0:ʏ`  1:Z`  2:RGB]  3:`PxS{  4:Zς݃uh[h̒ʏ`  5:Zς݃uh[hRGB]  6:Zς݃uh[h̕`Px4{ ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO Base3D_PixelLighting_Normal_PS_Code[ 2 ]/*[ 5 ]*//*[ 2 ]*//*[ 2 ]*/[ 84 ]/*[ 2 ]*/[ 7 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;



	// WRc`p̃VhE}bvւ̃_Op_VF[_[
	// /*[ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]*/
	// [ ov}bv̗L( 0: 1:L ) ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO Base3D_ShadowMap_VS_Code/*[ 3 ]*/[ 2 ] ;

	// WRc`p̃CeBOȂ_VF[_[
	// /*[ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]*/
	// [ tHO^Cv ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO Base3D_NoLighting_VS_Code/*[ 3 ]*/[ 4 ] ;

	// WRc`p̒_PʃCeBO_VF[_[
	// [ VhE}bv̗L( 0: 1:L ) ]
	// /*[ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]*/
	// /*[ ov}bv̗L( 0: 1:L ) ]*/
	// [ tHO^Cv ]
	// [ CgCfbNX ]
	// /*[ XyL̗L( 0: 1:L ) ]*/
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO Base3D_VertexLighting_VS_Code[ 2 ]/*[ 3 ]*//*[ 2 ]*/[ 4 ][ 20 ]/*[ 2 ]*/ ;

	// WRc`p̃VhE}bvւ̃_OpsNZVF[_[
	// [ sNZVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO Base3D_ShadowMap_Normal_PS_Code[ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// WRc`p̃CeBOȂsNZVF[_[
	// /*[ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]*/
	// [ ( 0:ʏ`  1:Z`  2:RGB]  3:`PxS{  4:Zς݃uh[h̒ʏ`  5:Zς݃uh[hRGB]  6:Zς݃uh[h̕`Px4{ ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO Base3D_NoLighting_Normal_PS_Code/*[ 5 ]*/[ 7 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// WRc`p̒_PʃCeBOsNZVF[_[
	// [ VhE}bv̗L( 0: 1:L ) ]
	// /* [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ] */
	// /* [ XyL}bv ( 0: 1: ) ] */
	// /* [ ov}bv ( 0:Ȃ 1: ) ] */
	// [ CgCfbNX ]
	// /*[ XyL̗L( 0: 1:L ) ]*/
	// [ ( 0:ʏ`  1:Z`  2:RGB]  3:`PxS{  4:Zς݃uh[h̒ʏ`  5:Zς݃uh[hRGB]  6:Zς݃uh[h̕`Px4{ ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO Base3D_VertexLighting_Normal_PS_Code[ 2 ]/*[ 5 ]*//*[ 2 ]*//*[ 2 ]*/[ 10 ]/*[ 2 ]*/[ 7 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;
} ;

#ifndef DX_NON_MODEL

// Direct3D11  f`p̃VF[_[R[ȟf[^Z߂\
struct GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_MODEL
{
	volatile int			ModelShaderInitializeFlag ;				// fp̃VF[_[oCĩZbgAbvĂ邩ǂ̃tO( TRUE:Ă  FALSE:ĂȂ )

	void					*ModelShaderPackImage ;					// RcfpVF[_[pbP[WoCiC[W

	// f`psNZPʃCeBO^Cv̒_VF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV 2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	// [ tHO^Cv ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MV1_PixelLighting_VS_Code[ 2 ][ 3 ][ 2 ][ 4 ] ;

	// f`psNZPʃCeBO^CṽgD[^CvPpsNZVF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// [ gD[_ÕXyLOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ LȃCg̐ - 1 ]
	// [ sNZVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MV1_PixelLighting_ToonType1_PS_Code[ 2 ][ 2 ][ 2 ][ 2 ][ DX_D3D11_COMMON_CONST_LIGHT_NUM ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// f`psNZPʃCeBO^CṽgD[^CvQpsNZVF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ gD[_ÕXtBA}bv̗Lƃuh^Cv( 0:XtBA}bv͖   1:MV1_LAYERBLEND_TYPE_MODULATE  2:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ LȃCg̐ - 1 ]
	// [ sNZVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MV1_PixelLighting_ToonType2_PS_Code[ 2 ][ 3 ][ DX_D3D11_COMMON_CONST_LIGHT_NUM ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// f`psNZPʃCeBO^CṽsNZVF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ LȃCg̐ - 1 ]
	// [ sNZVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MV1_PixelLighting_Normal_PS_Code[ 2 ][ 5 ][ 2 ][ DX_D3D11_COMMON_CONST_LIGHT_NUM ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;





	// f`p̃VhE}bvւ̃gD[_O֊s`p_VF[_[
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MV1_ToonOutLine_ShadowMap_VS_Code[ 3 ][ 2 ] ;

	// f`p̃gD[_O̗֊s`p_VF[_[
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	// [ tHO^Cv ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MV1_ToonOutLine_VS_Code[ 3 ][ 2 ][ 4 ] ;

	// f`p̃VhE}bvւ̃_Op_VF[_[
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MV1_ShadowMap_VS_Code[ 3 ][ 2 ] ;

	// f`p̃CeBOȂ_VF[_[
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	// [ tHO^Cv ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MV1_NoLighting_VS_Code[ 3 ][ 2 ][ 4 ] ;

	// f`p̒_PʃCeBO蒸_VF[_[
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	// [ tHO^Cv ]
	// [ CgCfbNX ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MV1_VertexLighting_VS_Code[ 2 ][ 3 ][ 2 ][ 4 ][ 20 ] ;

	// f`p̃VhE}bvւ̃gD[_OpsNZVF[_[
	// [ gD[_O^Cv( 0:gD[_O type 1   1:gD[_O type 2 ) ]
	// [ gD[_ÕXtBA}bv̗Lƃuh^Cv( 0:XtBA}bv͖   1:MV1_LAYERBLEND_TYPE_MODULATE  2:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MV1_ShadowMap_Toon_PS_Code[ 2 ][ 3 ][ 2 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// f`p̃VhE}bvւ̃_OpsNZVF[_[
	// [ sNZVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MV1_ShadowMap_Normal_PS_Code[ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// f`p̃CeBOȂgD[psNZVF[_[( Xg͔z̍ )
	// [ gD[_O^Cv( 0:gD[_O type 1   1:gD[_O type 2 ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT or gD[_Oł͂Ȃ  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MV1_NoLighting_Toon_PS_Code[ 2 ][ 2 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// f`p̃CeBOȂsNZVF[_[
	// [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]
	// [ sNZVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MV1_NoLighting_Normal_PS_Code[ 5 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// f`p̒_PʃCeBOgD[^CvPpsNZVF[_[
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// [ gD[_ÕXyLOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ CgCfbNX ]
	// [ sNZVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MV1_VertexLighting_ToonType1_PS_Code[ 2 ][ 2 ][ 2 ][ 2 ][ 10 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// f`p̒_PʃCeBOgD[^CvQpsNZVF[_[
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ gD[_ÕXtBA}bv̗Lƃuh^Cv( 0:XtBA}bv͖   1:MV1_LAYERBLEND_TYPE_MODULATE  2:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ CgCfbNX ]
	// [ sNZVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MV1_VertexLighting_ToonType2_PS_Code[ 2 ][ 3 ][ 10 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;

	// f`p̒_PʃCeBOsNZVF[_[
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ CgCfbNX ]
	// [ sNZVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO MV1_VertexLighting_Normal_PS_Code[ 2 ][ 5 ][ 2 ][ 10 ][ DIRECT3D11_PS_ALPHATEST_NUM ] ;
} ;

#endif // DX_NON_MODEL


// VF[_[R[ȟf[^Z߂\
struct GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE
{
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_BASE	Base ;				// W`揈p̃VF[_[R[hZ߂\
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_BASE3D	Base3D ;			// WRc`揈p̃VF[_[R[hZ߂\

#ifndef DX_NON_MODEL
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_MODEL	Model ;				// f`揈p̃VF[_[R[hZ߂\
#endif // DX_NON_MODEL
} ;

// A_v^[ӂ̏\
struct GRAPHICS_HARDWARE_DIRECT3D11_ADAPTER_UNIT
{
	D_DXGI_ADAPTER_DESC								Desc ;						// A_v^̏

	int												OutputNum ;					// o͐̐
	D_DXGI_OUTPUT_DESC								OutputDesc[ DX_D3D11_MAX_OUTPUT_LISTUP ] ; // o͐̏
} ;


// A_v^[֌W\
struct GRAPHICS_HARDWARE_DIRECT3D11_ADAPTER
{
	int												ValidInfo ;					// A_v^̏񂪗Lǂ( TRUE:L  FALSE: )
	int												InfoNum ;					// A_v^̐
	GRAPHICS_HARDWARE_DIRECT3D11_ADAPTER_UNIT		Info[ DX_D3D11_MAX_ADAPTER_LISTUP ] ;	// A_v^̏

//	int												ValidUseOutputNumber ;		// UseOutputNumber Lǂ( TRUE:L  FALSE: )
//	int												UseOutputNumber ;			// gpo͔ԍ
} ;


// Direct3D11 ֌W̐ݒ̍\
struct GRAPHICS_HARDDATA_DIRECT3D11_SETTING
{
	D_D3D_FEATURE_LEVEL				FeatureLevel ;								// gpĂ@\x
	int								UseMinFeatureLevelDirect3D11 ;				// Direct3D11 ŎgpŒ@\x
	int								UserDepthBufferSizeSet ;					// O[xobt@TCY̎w肪ǂ
	int								UserDepthBufferBitDepthSet ;				// O[xobt@̃rbg[xw肪ǂ

	int								UseOldDrawModiGraphCodeFlag ;				// ȑO DrawModiGraph ֐R[hgp邩ǂ̃tO
} ;



// Direct3D11 ̃eNX`p̍\
struct GRAPHICS_HARDDATA_DIRECT3D11_TEXTURE
{
	void *											CommonBuffer ;					// eNX`摜]p̋L
	unsigned int									CommonBufferSize ;				// eNX`摜]p̋L̃TCY
} ;

// Direct3D11 gOtBbNX̍\
struct GRAPHICS_HARDDATA_DIRECT3D11
{
	int												UsePixelLightingShader ;	// sNZPʂŃCeBOs^CṽVF[_[gp邩ǂ( TRUE:gp  FALSE:gpȂ )

#ifndef DX_NON_MODEL
	D_ID3D11Texture3D *								RGBtoVMaxRGBVolumeTexture ;			// RGBJ[PxőɂRGBlɕϊ邽߂̃{[eNX`
	D_ID3D11ShaderResourceView *					RGBtoVMaxRGBVolumeTextureSRV ;		// RGBJ[PxőɂRGBlɕϊ邽߂̃{[eNX`̃VF[_[\[Xr[
#endif // DX_NON_MODEL

	GRAPHICS_HARDDATA_DIRECT3D11_SETTING			Setting ;					// Direct3D11 ֌W̐ݒ

	GRAPHICS_HARDDATA_DIRECT3D11_DEVICE				Device ;					// D3D11Device ɖڂɊ֘A

	GRAPHICS_HARDWARE_DIRECT3D11_ADAPTER			Adapter ;					// A_v^[֌W

	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE			ShaderCode ;				// D_ID3D11PixelShader  D_ID3D11VertexShader ̌ƂȂVF[_[R[hf[^Z߂\

	GRAPHICS_HARDDATA_DIRECT3D11_TEXTURE			Texture ;					// Direct3D11 ̃eNX`p̍\
} ;


// ϐ錾 --------------------------------------------------------------

extern GRAPHICS_HARDDATA_DIRECT3D11 GraphicsHardDataDirect3D11 ;

// ֐vg^Cv錾-----------------------------------------------------------

// Direct3D11 ̏֌W
extern	int		Graphics_D3D11_Initialize( void ) ;								// Direct3D11 gpOtBbNX̏s( 0: -1:s )
extern	int		Graphics_D3D11_Terminate( void ) ;								// Direct3D11 gpOtBbNX̌ns

extern	int		Graphics_D3D11_ReleaseObjectAll( void ) ;						// ׂĂ Direct3D11 nIuWFNg
extern	int		Graphics_D3D11_CreateObjectAll( void ) ;						// ׂĂ Direct3D11 nIuWFNg쐬










// VF[_[R[h֌W
extern	int		Graphics_D3D11_ShaderCode_Base_Initialize( void ) ;				// Direct3D11 ̕W`p̃VF[_[R[h̏s
extern	int		Graphics_D3D11_ShaderCode_Base_Terminate( void ) ;				// Direct3D11 ̕W`p̃VF[_[R[ȟns

extern	int		Graphics_D3D11_ShaderCode_Base3D_Initialize( void ) ;			// Direct3D11 ̕WRc`p̃VF[_[R[h̏s
extern	int		Graphics_D3D11_ShaderCode_Base3D_Terminate( void ) ;			// Direct3D11 ̕WRc`p̃VF[_[R[ȟns

#ifndef DX_NON_MODEL

extern	int		Graphics_D3D11_ShaderCode_Model_Initialize( void ) ;			// Direct3D11 ̃f`p̃VF[_[R[h̏s
extern	int		Graphics_D3D11_ShaderCode_Model_Terminate( void ) ;				// Direct3D11 ̃f`p̃VF[_[R[ȟns

#endif // DX_NON_MODEL

extern	int		Graphics_D3D11_Shader_Initialize( void ) ;						// Direct3D11 ̃VF[_[̏s
extern	int		Graphics_D3D11_Shader_Terminate( void ) ;						// Direct3D11 ̃VF[_[̌n

extern	int		Graphics_D3D11_VertexShader_Create( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO *Code, D_ID3D11VertexShader **pDestShader, int Num ) ;		// VF[_[R[h璸_VF[_[쐬
extern	int		Graphics_D3D11_PixelShader_Create(  GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO *Code, D_ID3D11PixelShader  **pDestShader, int Num ) ;		// VF[_[R[hsNZVF[_[쐬

extern	int		Graphics_D3D11_Shader_Normal3DDraw_Setup( void ) ;				// RcW`̎w̒_p̕`pVF[_[ZbgAbv
extern	int		Graphics_D3D11_Shader_GetAlphaTestModeIndex( int AlphaTestEnable, int AlphaTestMode /* DX_CMP_NEVER  */ ) ;	// At@eXg̔r[hsNZVF[_[̃At@eXg[h( DIRECT3D11_PS_ALPHATEST_CMP_GREATER  )擾










// _obt@ECfbNXobt@֌W
extern	int		Graphics_D3D11_VertexBuffer_CreateObject(  VERTEXBUFFERHANDLEDATA *VertexBuffer, int Restore ) ;	// _obt@nhp ID3D11Buffer IuWFNg쐬
extern	int		Graphics_D3D11_VertexBuffer_ReleaseObject( VERTEXBUFFERHANDLEDATA *VertexBuffer ) ;					// _obt@nhp ID3D11Buffer IuWFNg
extern	int		Graphics_D3D11_IndexBuffer_CreateObject(   INDEXBUFFERHANDLEDATA *IndexBuffer,   int Restore ) ;	// CfbNXobt@nhp ID3D11Buffer IuWFNg쐬
extern	int		Graphics_D3D11_IndexBuffer_ReleaseObject(  INDEXBUFFERHANDLEDATA *IndexBuffer ) ;					// CfbNXobt@nhp ID3D11Buffer IuWFNg










// Direct3D11 ̉ʊ֌W
extern	int		Graphics_D3D11_OutputWindow_Add( HWND TargetWindow, int IsMainTarget = FALSE ) ;					// o͐EChE̒ǉs( -1:s  -1ȊO:ΏۃEChEp̔zCfbNX )
extern	int		Graphics_D3D11_OutputWindow_Sub( HWND TargetWindow, int Index = -1 ) ;								// w̃EChEo͐EChEO
extern	int		Graphics_D3D11_OutputWindow_SetupBuffer( int Index ) ;												// w̏o͐EChEp̃obNobt@[ZbgAbv
extern	int		Graphics_D3D11_OutputWindow_ReleaseBuffer( int Index ) ;											// w̏o͐EChEp̃obNobt@[̌n
extern	int		Graphics_D3D11_OutputWindow_ResizeBuffer( int Index, int NewSizeX, int NewSizeY ) ;					// w̏o͐EChẼobNobt@̃TCYύX
extern	int		Graphics_D3D11_OutputWindow_Present( int Index, RECT *BackScreenRect, RECT *WindowClientRect ) ;	// w̏o͐EChE̎ẅ̗Ɏw̃obNobt@̗̈]
extern	int		Graphics_D3D11_SetupSubBackBuffer( void ) ;															// TuobNobt@gp鏀s( 0:  -1:s )
extern	int		Graphics_D3D11_CreateDepthBuffer( void ) ;															// [xobt@IuWFNg̍쐬( 0:  -1:s )















// Direct3D11 ̉摜֌W
extern COLORDATA *Graphics_D3D11_GetD3DFormatColorData( D_DXGI_FORMAT Format ) ;									// D_DXGI_FORMAT ̃tH[}bgɍ킹J[tH[}bg擾

// `peNX`ƕ`peNX`ĂꍇɁA`peNX`ɕ`peNX`̓e𔽉f
extern	int		Graphics_D3D11_UpdateDrawTexture( IMAGEDATA_ORIG_HARD_TEX *OrigTex, int TargetSurface, D_DXGI_FORMAT Format ) ;

// {C[W̃tH[}bg DX_BASEIMAGE_FORMAT_NORMAL ɕϊKv邩ǂ`FbN
// ( RequiredRgbBaseImageConvFlag  RequiredAlphaBaseImageConvFlag ɓl  TRUE:ϊKv  FALSE:ϊKv͖ )
extern	int		Graphics_D3D11_CheckRequiredNormalImageConv_BaseImageFormat_PF(
	IMAGEDATA_ORIG *Orig,
	int             RgbBaseImageFormat,
	int            *RequiredRgbBaseImageConvFlag,
	int             AlphaBaseImageFormat = -1,
	int            *RequiredAlphaBaseImageConvFlag = NULL
) ;

extern	int		Graphics_D3D11_Texture_SetupCommonBuffer( unsigned int Size ) ;		// eNX`摜]p̋L̃ZbgAbvs
extern	int		Graphics_D3D11_Texture_TerminateCommonBuffer( void ) ;				// eNX`摜]p̋Ľns

extern	int		Graphics_D3D11_StretchRect_Initialize( void ) ;				// P]̏s
extern	int		Graphics_D3D11_StretchRect_Terminate( void ) ;				// P]̌ns

// _[^[QbgeNX`ɃeNX`̒P]s
extern	int		Graphics_D3D11_StretchRect(
	D_ID3D11Texture2D *SrcTexture,          D_ID3D11ShaderResourceView  *SrcTextureSRV,          const RECT *SrcRect  /* NULL őS */,
	D_ID3D11Texture2D *DestTexture,         D_ID3D11RenderTargetView    *DestTextureRTV,         const RECT *DestRect /* NULL őS */,
	D_D3D11_FILTER_TYPE FilterType = D_D3D11_FILTER_TYPE_POINT,
	int AlphaBlend = FALSE,
	D_ID3D11VertexShader *VertexShader = NULL,
	D_ID3D11PixelShader  *PixelShader  = NULL,
	D_ID3D11Texture2D *BlendTexture = NULL, D_ID3D11ShaderResourceView  *BlendTextureSRV = NULL, const RECT *BlendRect = NULL /* NULL őS */,
	VERTEX_TEX8_2D *Texcoord8Vertex = NULL
) ;

// w̃eNX`̓eɓǂݍ݃ANZXł悤ɂ
extern	int		Graphics_D3D11_Texture2D_Map(
	D_ID3D11Texture2D *				TargetTexture,
	D_ID3D11ShaderResourceView *	TargetTextureSRV,
	int								TargetTextureArraySlice,
	int								TargetTextureMipSlice,
	const RECT *					MapRect /* NULL őS */,
	BASEIMAGE *						MapBaseImage,
	D_ID3D11Texture2D **			MapTempTexture
) ;

// w̃eNX`̓eւ̓ǂݍ݃ANZXI
extern	int		Graphics_D3D11_Texture2D_Unmap( D_ID3D11Texture2D *MapTempTexture ) ;







// D3D11Device ̏֌W
extern	int		Graphics_D3D11_Device_Create( void ) ;																// Direct3DDevice11 IuWFNg̍쐬( 0:  -1:s )

extern	int		Graphics_D3D11_Device_Initialize( void ) ;															// Direct3DDevice11 ֌W̏
extern	int		Graphics_D3D11_Device_ReInitialize( void ) ;														// ꎞI Direct3DDevice11 jۂɁAjȌԂo߂̊֐






// DXGIAdapter ֌W
extern	int		EnumDXGIAdapterInfo( void ) ;																		// DXGIIuWFNg̗








// D3D11Device Xe[^X֌W
extern	void	Graphics_D3D11_DeviceState_RefreshRenderState( void ) ;												// `ݒtbV
extern	int		Graphics_D3D11_DeviceState_SetBaseState( void ) ;													// Direct3DDevice11 ̊{ݒs
extern	int		Graphics_D3D11_DeviceState_SetSampleFilterMode( D_D3D11_FILTER Filter, int Sampler = -1 ) ;			// Tv[̃eNX`tB^O[hݒ肷
extern	int		Graphics_D3D11_DeviceState_SetDepthEnable( BOOL DepthEnable )  ;									// [xobt@̗L̃Zbg
extern	int		Graphics_D3D11_DeviceState_SetDepthWriteEnable( int Flag ) ;										// [xobt@݂̗̏LZbg
extern	int		Graphics_D3D11_DeviceState_SetDepthFunc( D_D3D11_COMPARISON_FUNC DepthFunc ) ;						// [xl̔r^CvZbg
extern	int		Graphics_D3D11_DeviceState_SetDepthBias( int DepthBias ) ;											// [xl̃oCAXZbg
extern	int		Graphics_D3D11_DeviceState_SetFillMode( D_D3D11_FILL_MODE FillMode ) ;								// tB[hZbg
extern	int		Graphics_D3D11_DeviceState_SetWorldMatrix( const MATRIX *Matrix ) ;									// [hϊpsZbg
extern	int		Graphics_D3D11_DeviceState_SetViewMatrix( const MATRIX *Matrix ) ;									// r[ϊpsZbg
extern	int		Graphics_D3D11_DeviceState_SetProjectionMatrix( const MATRIX *Matrix ) ;							// eϊpsZbg
extern	int		Graphics_D3D11_DeviceState_SetAntiViewportMatrix( const MATRIX *Matrix ) ;							// A`r[|[gsZbg
extern	int		Graphics_D3D11_DeviceState_SetLightState( int LightNumber, LIGHTPARAM *Light ) ;					// Cg̃Zbg
extern	int		Graphics_D3D11_DeviceState_SetLightEnable( int LightNumber, int EnableState ) ;						// Cg̗LAύX
extern	int		Graphics_D3D11_DeviceState_SetMaterial( MATERIALPARAM *Material ) ;									// }eÃZbg
extern	int		Graphics_D3D11_DeviceState_SetSpecularEnable( int UseFlag ) ;										// XyLgp邩ǂZbg
extern	int		Graphics_D3D11_DeviceState_SetUseVertexDiffuseColor( int UseFlag ) ;								// _̃fBt[YJ[}eÃfBt[YJ[ƂĎgp邩ǂݒ肷
extern	int		Graphics_D3D11_DeviceState_SetUseVertexSpecularColor( int UseFlag ) ;								// _̃XyLJ[}eÃXyLJ[ƂĎgp邩ǂݒ肷
extern	int		Graphics_D3D11_DeviceState_SetCullMode( int State ) ;												// JO̗LZbg 
extern	int		Graphics_D3D11_DeviceState_SetAmbient( COLOR_F *Color ) ;												// ArGgJ[̃Zbg
extern	int		Graphics_D3D11_DeviceState_SetTextureAddress( int AddressMode, int Sampler = -1 ) ;					// eNX`[̃AhbVO[hZbg
extern	int		Graphics_D3D11_DeviceState_SetTextureAddressU( int AddressMode, int Sampler = -1 ) ;				// eNX`[̃AhbVO[hZbg
extern	int		Graphics_D3D11_DeviceState_SetTextureAddressV( int AddressMode, int Sampler = -1 ) ;				// eNX`[̃AhbVO[hZbg
extern	int		Graphics_D3D11_DeviceState_SetTextureAddressW( int AddressMode, int Sampler = -1 ) ;				// eNX`[̃AhbVO[hZbg
extern	int		Graphics_D3D11_DeviceState_SetTextureAddressUVW( int AddressModeU, int AddressModeV, int AddressModeW, int Sampler = -1 ) ;		// eNX`[̃AhbVO[hZbg
extern	int		Graphics_D3D11_DeviceState_SetTextureAddressTransformMatrix( int Use, MATRIX *Matrix ) ;			// eNX`WϊsZbg
extern	int		Graphics_D3D11_DeviceState_SetFogEnable( int Flag ) ;												// tHOLɂ邩ǂݒ肷( TRUE:L  FALSE: )
extern	int		Graphics_D3D11_DeviceState_SetFogVertexMode( int Mode /* DX_FOGMODE_NONE  */ ) ;					// tHO[hݒ肷
extern	int		Graphics_D3D11_DeviceState_SetFogColor( unsigned int Color ) ;												// tHOJ[ύX
extern	int		Graphics_D3D11_DeviceState_SetFogStartEnd( float Start, float End ) ;								// tHOn܂鋗ƏI鋗ݒ肷( 0.0f ` 1.0f )
extern	int		Graphics_D3D11_DeviceState_SetFogDensity( float Density ) ;											// tHO̖xݒ肷( 0.0f ` 1.0f )
extern	int		Graphics_D3D11_DeviceState_SetLighting( int UseFlag ) ;												// CeBO̗LtOZbg
extern	int		Graphics_D3D11_DeviceState_SetMaxAnisotropy( int MaxAnisotropy, int Sampler = -1 ) ;				// őٕZbg
extern	int		Graphics_D3D11_DeviceState_SetViewport( D_D3D11_VIEWPORT *Viewport ) ;								// r[|[gZbg
extern	int		Graphics_D3D11_DeviceState_SetViewportEasy( float x1, float y1, float x2, float y2 ) ;				// r[|[gZbg( ȈՔ )
extern	int		Graphics_D3D11_DeviceState_SetDrawMode( int DrawMode ) ;											// `惂[h̃Zbg
extern	int		Graphics_D3D11_DeviceState_SetAlphaTestCmpMode( int AlphaTestCmpMode /* DX_CMP_NEVER Ȃ */ ) ;	// At@eXgŎgpr[hݒ肷
extern	int		Graphics_D3D11_DeviceState_SetAlphaTestRef( int AlphaTestRef ) ;									// At@eXgŎgpQƒlݒ肷
extern	int		Graphics_D3D11_DeviceState_SetMulAlphaColor( int UseMulAlphaColor ) ;								// J[ɃAt@lZ邩ǂݒ肷
extern	int		Graphics_D3D11_DeviceState_SetPrimitiveTopology( D_D3D11_PRIMITIVE_TOPOLOGY PrimitiveTopology ) ;	// foCXŎgpv~eBu^Cvݒ肷
extern	int		Graphics_D3D11_DeviceState_SetFactorColor( const DX_D3D11_SHADER_FLOAT4 *FactorColor ) ;			// Factor Color ݒ肷
extern	int		Graphics_D3D11_DeviceState_SetToonOutLineSize( float Size ) ;										// gD[_O̗֊s̑ݒ肷
extern	int		Graphics_D3D11_DeviceState_SetBlendMode( int BlendMode ) ;											// `uh[h̃Zbg
extern	int		Graphics_D3D11_DeviceState_SetRenderTarget( D_ID3D11Texture2D *RenderTargetTexture, D_ID3D11RenderTargetView *RenderTargetView, int TargetIndex = 0 ) ;	// `Ώۂ̕ύX
extern	int		Graphics_D3D11_DeviceState_SetDepthStencil( D_ID3D11Texture2D *DepthStencilTexture, D_ID3D11DepthStencilView *DepthStencilView ) ;	// `Ώۂ̐[xobt@ύX
extern	int		Graphics_D3D11_DeviceState_SetInputLayout( D_ID3D11InputLayout *InputLayout ) ;						// gp̓CAEgύX
extern	int		Graphics_D3D11_DeviceState_SetVertexShaderToHandle( int ShaderHandle ) ;								// w̒_VF[_[foCXɃZbg
extern	int		Graphics_D3D11_DeviceState_SetVertexShader( D_ID3D11VertexShader *VertexShader, int NormalVertexShader = FALSE ) ;	// gp钸_VF[_[ύX
extern	int		Graphics_D3D11_DeviceState_ResetVertexShader( int SetNormalVertexShaderCancel = FALSE ) ;						// _VF[_[̎gp~߂
extern	int		Graphics_D3D11_DeviceState_SetVertexShaderConstantBuffers( UINT StartSlot, UINT NumBuffers, D_ID3D11Buffer * const *pConstantBuffers ) ;	// _VF[_[Ŏgp萔obt@[ݒ肷
extern	int		Graphics_D3D11_DeviceState_SetPixelShaderToHandle( int ShaderHandle ) ;								// w̃sNZVF[_[foCXɃZbg
extern	int		Graphics_D3D11_DeviceState_SetPixelShader( D_ID3D11PixelShader *PixelShader, int NormalPixelShader = FALSE ) ;	// gpsNZVF[_[ύX
extern	int		Graphics_D3D11_DeviceState_ResetPixelShader( int SetNormalPixelShaderCancel = FALSE ) ;							// sNZVF[_[̎gp~߂
extern	int		Graphics_D3D11_DeviceState_SetPixelShaderConstantBuffers( UINT StartSlot, UINT NumBuffers, D_ID3D11Buffer * const *pConstantBuffers ) ;	// sNZVF[_[Ŏgp萔obt@[ݒ肷
extern	int		Graphics_D3D11_DeviceState_SetVertexBuffer( D_ID3D11Buffer *VertexBuffer, int VertexStride = 0 ) ;	// gp钸_obt@ύX
extern	int		Graphics_D3D11_DeviceState_SetIndexBuffer( D_ID3D11Buffer *IndexBuffer, D_DXGI_FORMAT Format ) ;	// gpCfbNXobt@ύX
extern	int		Graphics_D3D11_DeviceState_SetPSShaderResouceView( int StartSlot, int Num, D_ID3D11ShaderResourceView * const *ppShaderResourceViews ) ;	// sNZVF[_[ŎgpVF[_[\[Xr[ύX
extern	int		Graphics_D3D11_DeviceState_NormalDrawSetup( void ) ;												// W`̏s
extern	int		Graphics_D3D11_DeviceState_SetupStateAndConstantBuffer( void ) ;									// ݂̐ݒɊÂ ID3D11SamplerStateAID3D11RasterizerStateAID3D11DepthStencilStateAID3D11BlendState ̃ZbgAbvƁA萔obt@̃Abvf[gs






// `ݒ֌W֐
extern	int		Graphics_D3D11_DrawSetting_SetDrawBlendMode( int BlendMode, int AlphaTestValidFlag, int AlphaChannelValidFlag ) ;	// `uh[h̐ݒ
extern	int		Graphics_D3D11_DrawSetting_SetIgnoreDrawGraphColor( int EnableFlag ) ;							// `掞̉摜̐F𖳎邩ǂݒ肷
extern	int		Graphics_D3D11_DrawSetting_SetDrawAlphaTest( int TestMode, int TestParam ) ;					// At@eXg̐ݒ
extern	int		Graphics_D3D11_DrawSetting_SetBlendTextureParam( int BlendType, int *Param ) ;					// uheNX`̃p[^Zbg
extern	int		Graphics_D3D11_DrawSetting_SetTexture(      D_ID3D11Texture2D *RenderTexture, D_ID3D11ShaderResourceView *RenderTextureSRV ) ;											// eNX`Zbg 
extern	int		Graphics_D3D11_DrawSetting_SetBlendTexture( D_ID3D11Texture2D *BlendTexture,  D_ID3D11ShaderResourceView *BlendTextureSRV, int TexWidth = -1, int TexHeight = -1 ) ;	// uheNX`Zbg 









// 萔֌W֐
extern int Graphics_D3D11_Constant_Initialize( void ) ;												// Direct3D11 ̒萔̏s
extern int Graphics_D3D11_Constant_Terminate( void ) ;												// Direct3D11 ̒萔̌ns








// 萔obt@֌W֐
extern	CONSTANTBUFFER_DIRECT3D11 *Graphics_D3D11_ConstantBuffer_Create( DWORD Size, int ASyncThread = FALSE ) ;	// 萔obt@쐬
extern	int		Graphics_D3D11_ConstantBuffer_Delete( CONSTANTBUFFER_DIRECT3D11 *ConstantBuffer ) ;					// 萔obt@폜
extern	int		Graphics_D3D11_ConstantBuffer_Update( CONSTANTBUFFER_DIRECT3D11 *ConstantBuffer ) ;					// VXẽobt@ɍsύXKp
extern	int		Graphics_D3D11_ConstantBuffer_VSSet( UINT StartSlot, UINT NumBuffers, CONSTANTBUFFER_DIRECT3D11 * const *pConstantBuffers ) ;	// w̒萔obt@𒸓_VF[_[ɐݒ肷
extern	int		Graphics_D3D11_ConstantBuffer_PSSet( UINT StartSlot, UINT NumBuffers, CONSTANTBUFFER_DIRECT3D11 * const *pConstantBuffers ) ;	// w̒萔obt@sNZVF[_[ɐݒ肷









// ̓CAEg֌W֐
extern	int		Graphics_D3D11_InputLayout_Base_Create( void ) ;		// W`p ID3D11InputLayout IuWFNg̍쐬( 0:  -1:s )
extern	int		Graphics_D3D11_InputLayout_Base_Terminate( void ) ;		// W`p ID3D11InputLayout IuWFNg̍폜( 0:  -1:s )

#ifndef DX_NON_MODEL
extern	int		Graphics_D3D11_InputLayout_Model_Create( int BumpMap, int MeshType ) ;	// f`p ID3D11InputLayout IuWFNg̍쐬( 0:  -1:s )
extern	int		Graphics_D3D11_InputLayout_Model_Terminate( void ) ;					// f`p ID3D11InputLayout IuWFNg̍폜( 0:  -1:s )
#endif // DX_NON_MODEL








// W`֌W
extern	int		Graphics_D3D11_NormalDrawVertexBuffer_Create( void ) ;		// W`p̒_obt@̍쐬( 0:  -1:s )
extern	int		Graphics_D3D11_NormalDrawVertexBuffer_Terminate( void ) ;	// W`p̒_obt@̍폜( 0:  -1:s )

extern	int		Graphics_D3D11_CommonBuffer_DrawPrimitive(        int InputLayout, D_D3D11_PRIMITIVE_TOPOLOGY PrimitiveType, const void *VertexData, int VertexNum,                                                                 int UseDefaultVertexShader = TRUE ) ;	// ėp`p_obt@gpăVXe̒_f[^̕`s
extern	int		Graphics_D3D11_CommonBuffer_DrawIndexedPrimitive( int InputLayout, D_D3D11_PRIMITIVE_TOPOLOGY PrimitiveType, const void *VertexData, int VertexNum, const void *IndexData, int IndexNum, D_DXGI_FORMAT IndexFormat, int UseDefaultVertexShader = TRUE ) ;	// ėp`p_obt@ECfbNXobt@gpăVXe̒_f[^ECfbNXf[^̕`s
extern	int		Graphics_D3D11_CommonVertexBuffer_Setup( int Size ) ;		// wTCY̔ėp`p_obt@̏s
extern	int		Graphics_D3D11_CommonIndexBuffer_Setup( int Size ) ;		// wTCY̔ėp`pCfbNXobt@̏s
extern	int		Graphics_D3D11_CommonVertexBuffer_Terminate( void ) ;		// ėp`p_obt@̌ns
extern	int		Graphics_D3D11_CommonIndexBuffer_Terminate( void ) ;		// ėp`pCfbNXobt@̌ns













// Direct3D11 ̕`揈֌W
extern	int		Graphics_D3D11_RenderVertex( int NextUse3DVertex = -1, int ASyncThread = FALSE ) ;	// _obt@ɗ܂_f[^_O
extern	void	FASTCALL Graphics_D3D11_DrawPreparation( int ParamFlag = 0 ) ;						// `揀s
extern	void	Graphics_D3D11_RenderBegin( void ) ;												// `R}hJn
extern	void	Graphics_D3D11_RenderEnd( void ) ;													// `R}hI












// Direct3D11 g`֌W
extern	int		Graphics_D3D11_DrawBillboard3D( VECTOR Pos, float cx, float cy, float Size, float Angle, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int TurnFlag, int DrawFlag = TRUE, RECT *DrawArea = NULL ) ;	// n[hEGAANZ[^gp DrawBillboard3D
extern	int		Graphics_D3D11_DrawModiBillboard3D( VECTOR Pos, float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int DrawFlag = TRUE, RECT *DrawArea = NULL ) ;	// n[hEGAANZ[^gp DrawModiBillboard3D
extern	int		Graphics_D3D11_DrawGraph( int x, int y, float xf, float yf, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int IntFlag ) ;																// n[hEGAANZ[^gp DrawGraph
extern	int		Graphics_D3D11_DrawExtendGraph( int x1, int y1, int x2, int y2, float x1f, float y1f, float x2f, float y2f, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int IntFlag ) ;				// n[hEGAANZ[^gp DrawExtendGraph
extern	int		Graphics_D3D11_DrawRotaGraph( int x, int y, float xf, float yf, double ExRate, double Angle, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int TurnFlag, int IntFlag ) ;				// n[hEGAANZ[^gp DrawRotaGraph
extern	int		Graphics_D3D11_DrawRotaGraphFast( int x, int y, float xf, float yf, float ExRate, float Angle, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int TurnFlag, int IntFlag ) ;			// n[hEGAANZ[^gp DrawRotaGraphFast
extern	int		Graphics_D3D11_DrawModiGraph( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, bool SimpleDrawFlag ) ;					// n[hEGAANZ[^gp DrawModiGraph
extern	int		Graphics_D3D11_DrawModiGraphF( float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, bool SimpleDrawFlag ) ;	// n[hEGAANZ[^gp DrawModiGraphF
extern	void	Graphics_D3D11_DrawModiTex( float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, IMAGEDATA_HARD_DRAW *DrawTex, bool SimpleDrawFlag ) ;								// eNX`ό`ĕ`悷
extern	int		Graphics_D3D11_DrawSimpleQuadrangleGraphF( const GRAPHICS_DRAW_DRAWSIMPLEQUADRANGLEGRAPHF_PARAM *Param, IMAGEDATA *Image, IMAGEDATA *BlendImage ) ;												// n[hEGAANZ[^gp DrawSimpleQuadrangleGraphF
extern	int		Graphics_D3D11_DrawSimpleTriangleGraphF(   const GRAPHICS_DRAW_DRAWSIMPLETRIANGLEGRAPHF_PARAM   *Param, IMAGEDATA *Image, IMAGEDATA *BlendImage ) ;												// n[hEGAANZ[^gp DrawSimpleTriangleGraphF

extern	int		Graphics_D3D11_DrawFillBox( int x1, int y1, int x2, int y2, unsigned int Color ) ;																		// n[hEGAANZ[^gp DrawFillBox
extern	int		Graphics_D3D11_DrawLineBox( int x1, int y1, int x2, int y2, unsigned int Color ) ;																		// n[hEGAANZ[^gp DrawLineBox
extern	int		Graphics_D3D11_DrawLine( int x1, int y1, int x2, int y2, unsigned int Color ) ;																			// n[hEGAANZ[^gp DrawLine
extern	int		Graphics_D3D11_DrawLine3D( VECTOR Pos1, VECTOR Pos2, unsigned int Color, int DrawFlag = TRUE, RECT *DrawArea = NULL ) ;									// n[hEGAANZ[^gp DrawLine3D
extern	int		Graphics_D3D11_DrawCircle_Thickness( int x, int y, int r, unsigned int Color, int Thickness ) ;															// n[hEGAANZ[^gp DrawCircle( w肠 )
extern	int		Graphics_D3D11_DrawOval_Thickness( int x, int y, int rx, int ry, unsigned int Color, int Thickness ) ;													// n[hEGAANZ[^gp DrawOval( w肠 )
extern	int		Graphics_D3D11_DrawCircle( int x, int y, int r, unsigned int Color, int FillFlag, int Rx_One_Minus, int Ry_One_Minus ) ;								// n[hEGAANZ[^gp DrawCircle
extern	int		Graphics_D3D11_DrawOval( int x, int y, int rx, int ry, unsigned int Color, int FillFlag, int Rx_One_Minus, int Ry_One_Minus ) ;							// n[hEGAANZ[^gp DrawOval
extern	int		Graphics_D3D11_DrawTriangle( int x1, int y1, int x2, int y2, int x3, int y3, unsigned int Color, int FillFlag ) ;										// n[hEGAANZ[^gp DrawTriangle
extern	int		Graphics_D3D11_DrawTriangle3D( VECTOR Pos1, VECTOR Pos2, VECTOR Pos3, unsigned int Color, int FillFlag, int DrawFlag = TRUE, RECT *DrawArea = NULL ) ;	// n[hEGAANZ[^gp DrawTriangle3D
extern	int		Graphics_D3D11_DrawQuadrangle( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, unsigned int Color, int FillFlag ) ;						// n[hEGAANZ[^gp DrawQuadrangle
extern	int		Graphics_D3D11_DrawPixel( int x, int y, unsigned int Color ) ;																							// n[hEGAANZ[^gp DrawPixel
extern	int		Graphics_D3D11_DrawPixel3D( VECTOR Pos, unsigned int Color, int DrawFlag = TRUE, RECT *DrawArea = NULL ) ;												// n[hEGAANZ[^gp DrawPixel3D
extern	int		Graphics_D3D11_DrawPixelSet( const POINTDATA *PointData, int Num ) ;																				// n[hEGAANZ[^gp DrawPixelSet
extern	int		Graphics_D3D11_DrawLineSet( const LINEDATA *LineData, int Num ) ;																				// n[hEGAANZ[^gp DrawLineSet

extern	int		Graphics_D3D11_DrawPrimitive(                             const VERTEX_3D *Vertex, int VertexNum,                                    int PrimitiveType, IMAGEDATA *Image, int TransFlag ) ;
extern	int		Graphics_D3D11_DrawIndexedPrimitive(                      const VERTEX_3D *Vertex, int VertexNum, const WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag ) ;
extern	int		Graphics_D3D11_DrawPrimitiveLight(                        const VERTEX3D  *Vertex, int VertexNum,                                    int PrimitiveType, IMAGEDATA *Image, int TransFlag ) ;
extern	int		Graphics_D3D11_DrawIndexedPrimitiveLight(                 const VERTEX3D  *Vertex, int VertexNum, const WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag ) ;
extern	int		Graphics_D3D11_DrawPrimitiveLight_UseVertexBuffer(        VERTEXBUFFERHANDLEDATA *VertexBuffer,                                      int PrimitiveType,                 int StartVertex, int UseVertexNum, IMAGEDATA *Image, int TransFlag ) ;
extern	int		Graphics_D3D11_DrawIndexedPrimitiveLight_UseVertexBuffer( VERTEXBUFFERHANDLEDATA *VertexBuffer, INDEXBUFFERHANDLEDATA *IndexBuffer,  int PrimitiveType, int BaseVertex, int StartVertex, int UseVertexNum, int StartIndex, int UseIndexNum, IMAGEDATA *Image, int TransFlag ) ;
extern	int		Graphics_D3D11_DrawPrimitive2D(                                 VERTEX_2D *Vertex, int VertexNum,                                    int PrimitiveType, IMAGEDATA *Image, int TransFlag, int BillboardFlag, int Is3D, int TurnFlag, int TextureNo, int IsShadowMap ) ;
extern	int		Graphics_D3D11_DrawPrimitive2DUser(                       const VERTEX2D  *Vertex, int VertexNum,                                    int PrimitiveType, IMAGEDATA *Image, int TransFlag, int Is3D, int TurnFlag, int TextureNo ) ;
extern	int		Graphics_D3D11_DrawIndexedPrimitive2DUser(                const VERTEX2D  *Vertex, int VertexNum, const WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag ) ;

extern	void	Graphics_D3D11_DrawPreparationToShader( int ParamFlag, int Is2D ) ;											// VF[_[`p`OZbgAbv֐

extern	int		Graphics_D3D11_DrawPrimitive2DToShader(        const VERTEX2DSHADER *Vertex, int VertexNum,                                              int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ ) ;		// VF[_[gĂQcv~eBu`悷
extern	int		Graphics_D3D11_DrawPrimitive3DToShader(        const VERTEX3DSHADER *Vertex, int VertexNum,                                              int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ ) ;		// VF[_[gĂRcv~eBu`悷
extern	int		Graphics_D3D11_DrawPrimitiveIndexed2DToShader( const VERTEX2DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int IndexNum, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ ) ;		// VF[_[gĂQcv~eBu`悷( _CfbNXgp )
extern	int		Graphics_D3D11_DrawPrimitiveIndexed3DToShader( const VERTEX3DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int IndexNum, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ ) ;		// VF[_[gĂRcv~eBu`悷( _CfbNXgp )

extern	int		Graphics_D3D11_DrawPrimitive3DToShader_UseVertexBuffer2(        int VertexBufHandle,                     int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */, int StartVertex, int UseVertexNum ) ;	// VF[_[gĂRcv~eBu`悷( _obt@gp )
extern	int		Graphics_D3D11_DrawPrimitiveIndexed3DToShader_UseVertexBuffer2( int VertexBufHandle, int IndexBufHandle, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */, int BaseVertex, int StartVertex, int UseVertexNum, int StartIndex, int UseIndexNum ) ;	// VF[_[gĂRcv~eBu`悷( _obt@ƃCfbNXobt@gp )








// ˑ֌W
extern	int		Graphics_D3D11_Initialize_Timing0_PF( void ) ;											// `揈̊ˑ̏s֐( sӏʂO )
extern	int		Graphics_D3D11_Initialize_Timing1_PF( void ) ;											// `揈̊ˑ̏s֐( sӏʂQ )
extern	int		Graphics_D3D11_Hardware_Initialize_PF( void ) ;											// n[hEGAANZ[^gpꍇ̊ˑ̏s
extern	int		Graphics_D3D11_Terminate_PF( void ) ;													// `揈̊ˑ̌ns֐
extern	int		Graphics_D3D11_RestoreOrChangeSetupGraphSystem_PF( int Change, int ScreenSizeX = -1, int ScreenSizeY = -1, int ColorBitDepth = -1, int RefreshRate = -1 ) ;		// OtBbNXVXe̕AA͕ύXt̍ăZbgAbvs
extern	int		Graphics_D3D11_Hardware_CheckValid_PF( void ) ;											// `pfoCXLǂ擾( ߂l  TRUE:L  FALSE: )
extern	void	Graphics_D3D11_ReleaseDirectXObject_PF( void ) ;											// DirectX ̃IuWFNg








// ˑVXe֌W
extern	void	Graphics_D3D11_WM_ACTIVATE_ActiveProcess_PF( void ) ;									// WM_ACTIVATE bZ[W̏ŁAEChE[hɃANeBuɂȂۂɌĂ΂֐









// ˑ`ݒ֌W
extern	int		Graphics_Hardware_D3D11_SetRenderTargetToShader_PF( int TargetIndex, int DrawScreen, int SurfaceIndex, int MipLevel ) ;	// VF[_[`ł̕`ݒ肷
extern	int		Graphics_Hardware_D3D11_SetDrawBrightToOneParam_PF( DWORD Bright ) ;											// SetDrawBright ̈
extern	int		Graphics_Hardware_D3D11_SetDrawBlendMode_PF( int BlendMode, int BlendParam ) ;								// `uh[hZbg
extern	int		Graphics_Hardware_D3D11_SetDrawAlphaTest_PF( int TestMode, int TestParam ) ;									// `掞̃At@eXg̐ݒs( TestMode:DX_CMP_GREATER( -1:ftHgɖ߂ )  TestParam:`At@lƂ̔rɎgpl )
extern	int		Graphics_Hardware_D3D11_SetDrawMode_PF( int DrawMode ) ;														// `惂[hZbg
extern	int		Graphics_Hardware_D3D11_SetDrawBright_PF( int RedBright, int GreenBright, int BlueBright ) ;					// `PxZbg
extern	int		Graphics_Hardware_D3D11_SetBlendGraphParamBase_PF( IMAGEDATA *BlendImage, int BlendType, int *Param ) ;		// SetBlendGraphParam ̉ϒp[^t
extern	int		Graphics_Hardware_D3D11_SetMaxAnisotropy_PF( int MaxAnisotropy ) ;											// őٕ̒lZbg
extern	int		Graphics_Hardware_D3D11_SetTransformToWorld_PF( const MATRIX *Matrix ) ;										// [hϊpsZbg
extern	int		Graphics_Hardware_D3D11_SetTransformToView_PF( const MATRIX *Matrix ) ;										// r[ϊpsZbg
extern	int		Graphics_Hardware_D3D11_SetTransformToProjection_PF( const MATRIX *Matrix ) ;								// eϊpsZbg
extern	int		Graphics_Hardware_D3D11_SetTransformToViewport_PF( const MATRIX *Matrix ) ;									// r[|[gsZbg
extern	int		Graphics_Hardware_D3D11_SetTextureAddressMode_PF( int Mode /* DX_TEXADDRESS_WRAP  */, int Stage ) ;		// eNX`AhX[hݒ肷
extern	int		Graphics_Hardware_D3D11_SetTextureAddressModeUV_PF( int ModeU, int ModeV, int Stage ) ;						// eNX`AhX[hݒ肷
extern	int		Graphics_Hardware_D3D11_SetTextureAddressTransformMatrix_PF( int UseFlag, MATRIX *Matrix, int Sampler = -1 ) ;// eNX`WϊsZbg
extern	int		Graphics_Hardware_D3D11_SetFogEnable_PF( int Flag ) ;														// tHOLɂ邩ǂݒ肷( TRUE:L  FALSE: )
extern	int		Graphics_Hardware_D3D11_SetFogMode_PF( int Mode /* DX_FOGMODE_NONE  */ ) ;									// tHO[hݒ肷
extern	int		Graphics_Hardware_D3D11_SetFogColor_PF( DWORD FogColor ) ;													// tHOJ[ύX
extern	int		Graphics_Hardware_D3D11_SetFogStartEnd_PF( float start, float end ) ;										// tHOn܂鋗ƏI鋗ݒ肷( 0.0f ` 1.0f )
extern	int		Graphics_Hardware_D3D11_SetFogDensity_PF( float density ) ;													// tHO̖xݒ肷( 0.0f ` 1.0f )
extern	int		Graphics_Hardware_D3D11_ApplyLigFogToHardware_PF( void ) ;													// {f[^ɐݒ肳ĂtHOn[hEFAɔf
extern	int		Graphics_Hardware_D3D11_SetUseOldDrawModiGraphCodeFlag_PF( int Flag ) ;										// ȑO DrawModiGraph ֐̃R[hgp邩ǂ̃tOZbg
extern	int		Graphics_Hardware_D3D11_RefreshAlphaChDrawMode_PF( void ) ;													// `ɐlނǂ̃tOXV








// ˑݒ֌W
extern	int		Graphics_Hardware_D3D11_SetUsePixelLighting_PF( int Flag ) ;																	// sNZPʂŃCeBOsǂݒ肷Av ShaderModel 3.0( TRUE:sNZPʂ̃CeBOs  FALSE:_Pʂ̃CeBOs( ftHg ) )
extern	int		Graphics_Hardware_D3D11_SetGraphicsDeviceRestoreCallbackFunction_PF( void (* Callback )( void *Data ), void *CallbackData ) ;	// OtBbNXfoCXXg畜AۂɌĂ΂R[obN֐ݒ肷
extern	int		Graphics_Hardware_D3D11_SetGraphicsDeviceLostCallbackFunction_PF( void (* Callback )( void *Data ), void *CallbackData ) ;		// OtBbNXfoCXXg畜AOɌĂ΂R[obN֐ݒ肷
extern	int		Graphics_Hardware_D3D11_RefreshDxLibDirect3DSetting_PF( void ) ;																// cwCûcRcݒȂ
extern	int		Graphics_D3D11_SetUseDirect3D11MinFeatureLevel_PF( int Level /* DX_DIRECT3D_11_FEATURE_LEVEL_10_0 Ȃ */ ) ;					// Direct3D11 ŎgpŒ@\xw肷֐łAADX_DIRECT3D_11_FEATURE_LEVEL_11_0 Ⴂ@\xł̐ȓ͕ۏ؂܂( ftHg DX_DIRECT3D_11_FEATURE_LEVEL_11_0 )








// ˑʊ֌W
extern	int		Graphics_Hardware_D3D11_SetupUseZBuffer_PF( void ) ;															// ݒɊÂĎgp[xobt@Zbg
extern	int		Graphics_Hardware_D3D11_ClearDrawScreenZBuffer_PF( const RECT *ClearRect ) ;									// ʂ̐[xobt@̏Ԃ
extern	int		Graphics_Hardware_D3D11_ClearDrawScreen_PF( const RECT *ClearRect ) ;										// ʂ̏Ԃ
extern	int		Graphics_Hardware_D3D11_SetDrawScreen_PF( int DrawScreen, int OldScreenSurface, int OldScreenMipLevel, IMAGEDATA *NewTargetImage, IMAGEDATA *OldTargetImage, SHADOWMAPDATA *NewTargetShadowMap, SHADOWMAPDATA *OldTargetShadowMap ) ;						// `ʂ̃Zbg
extern	int		Graphics_Hardware_D3D11_SetDrawScreen_Post_PF( int DrawScreen ) ;											// SetDrawScreen ̍ŌŌĂ΂֐
extern	int		Graphics_Hardware_D3D11_SetDrawArea_PF( int x1, int y1, int x2, int y2 ) ;									// `\̈̃Zbg
extern	int		Graphics_Hardware_D3D11_LockDrawScreenBuffer_PF( RECT *LockRect, BASEIMAGE *BaseImage, int TargetScreen, IMAGEDATA *TargetImage, int TargetScreenSurface, int TargetScreenMipLevel, int ReadOnly, int TargetScreenTextureNo ) ;	// `obt@bN
extern	int		Graphics_Hardware_D3D11_UnlockDrawScreenBuffer_PF( void ) ;													// `obt@AbN
extern	int		Graphics_Hardware_D3D11_ScreenCopy_PF( void ) ;																// ʂ̓e\ʂɕ`悷
extern	int		Graphics_Hardware_D3D11_WaitVSync_PF( int SyncNum ) ;														// M҂
extern	int		Graphics_Hardware_D3D11_ScreenFlipBase_PF( void ) ;															// ʂƕ\ʂ
extern	int		Graphics_Hardware_D3D11_BltRectBackScreenToWindow_PF( HWND Window, RECT BackScreenRect, RECT WindowClientRect ) ;		// ʂ̎ẅ̗EChẼNCAg̈̎ẅ̗ɓ]
extern	int		Graphics_Hardware_D3D11_SetScreenFlipTargetWindow_PF( HWND TargetWindow, double ScaleX, double ScaleY ) ;	// ScreenFlip ŉ摜]̃EChEݒ肷( NULL w肷Ɛݒ )
extern	int		Graphics_Hardware_D3D11_SetZBufferMode_PF( int ZBufferSizeX, int ZBufferSizeY, int ZBufferBitDepth ) ;		// Cʂ̂yobt@̐ݒύX
extern	int		Graphics_Hardware_D3D11_SetDrawZBuffer_PF( int DrawScreen, IMAGEDATA *Image ) ;								// `yobt@̃Zbg
extern	const void*	Graphics_Hardware_D3D11_GetUseDirect3D11Device_PF( void ) ;												// gpID3D11DeviceIuWFNg擾( ߂l ID3D11Device * ɃLXgĂ )
extern	const void*	Graphics_Hardware_D3D11_GetUseDirect3D11DeviceContext_PF( void ) ;										// gpID3D11DeviceContextIuWFNg擾( ߂l ID3D11DeviceContext * ɃLXgĂ )
extern	const void*	Graphics_Hardware_D3D11_GetUseDirect3D11BackBufferTexture2D_PF( void ) ;								// gp̃obNobt@ID3D11Texture2DIuWFNg擾( ߂l ID3D11Texture2D * ɃLXgĂ )
extern	const void*	Graphics_Hardware_D3D11_GetUseDirect3D11BackBufferRenderTargetView_PF( void ) ;							// gp̃obNobt@ID3D11RenderTargetViewIuWFNg擾( ߂l ID3D11RenderTargetView * ɃLXgĂ )
extern	const void*	Graphics_Hardware_D3D11_GetUseDirect3D11DepthStencilTexture2D_PF( void ) ;								// gp̐[xXeVobt@ID3D11Texture2DIuWFNg擾( ߂l ID3D11Texture2D * ɃLXgĂ )
extern	const void*	Graphics_Hardware_D3D11_GetGraphID3D11Texture2D_PF( IMAGEDATA *Image ) ;								// OtBbNnh ID3D11Texture2D 擾( Direct3D11 gpĂꍇ̂ݗL )( ߂l ID3D11Texture2D * ɃLXgĂ )
extern	const void*	Graphics_Hardware_D3D11_GetGraphID3D11RenderTargetView_PF( IMAGEDATA *Image ) ;							// OtBbNnh ID3D11RenderTargetView 擾( Direct3D11 gpĂāA MakeScreen ō쐬OtBbNnhł̂ݗL )( ߂l ID3D11RenderTargetView * ɃLXgĂ )
extern	int			Graphics_Hardware_D3D11_SetDrawScreen_ID3D11RenderTargetView_PF( const void *pID3D11RenderTargetView ) ; // w ID3D11RenderTargetView `Ώۂɂ








// ˑ擾֌W
extern	const COLORDATA *	Graphics_Hardware_D3D11_GetMainColorData_PF( void ) ;				// GetColor  GetColor2 ŎgpJ[f[^擾
extern	const COLORDATA *	Graphics_Hardware_D3D11_GetDispColorData_PF( void ) ;				// fBXv[̃J[f[^|C^𓾂
extern	DWORD				Graphics_Hardware_D3D11_GetPixel_PF( int x, int y ) ;				// wW̐F擾
extern	COLOR_F				Graphics_Hardware_D3D11_GetPixelF_PF( int x, int y ) ;				// wW̐F擾( float^ )








// ˑ摜֌W
extern	int		Graphics_Hardware_D3D11_UpdateGraphMovie_TheoraYUV_PF( MOVIEGRAPH *Movie, IMAGEDATA *Image ) ;			// YUVT[tFXg Theora ̓eOtBbNXnh̃eNX`ɓ]
extern	int		Graphics_Hardware_D3D11_GraphLock_PF( IMAGEDATA *Image, COLORDATA **ColorDataP, int WriteOnly ) ;		// OtBbN̈̃bN
extern	int		Graphics_Hardware_D3D11_GraphUnlock_PF( IMAGEDATA *Image ) ;												// OtBbN̈̃bN
extern	int		Graphics_Hardware_D3D11_CopyGraphZBufferImage_PF( IMAGEDATA *DestImage, IMAGEDATA *SrcImage ) ;			// OtBbN̂yobt@̏Ԃʂ̃OtBbN̂yobt@ɃRs[( DestGrHandle  SrcGrHandle yobt@Ă`\摜ŁAA`GCAX摜ł͂ȂƂ )
extern	int		Graphics_Hardware_D3D11_InitGraph_PF( void ) ;															// 摜f[^̏
extern	int		Graphics_Hardware_D3D11_FillGraph_PF( IMAGEDATA *Image, int Red, int Green, int Blue, int Alpha, int ASyncThread ) ;			// OtBbN̐FœhԂ
extern	int		Graphics_Hardware_D3D11_GetDrawScreenGraphBase_PF( IMAGEDATA *Image, IMAGEDATA *TargetImage, int TargetScreen, int TargetScreenSurface, int TargetScreenMipLevel, int TargetScreenWidth, int TargetScreenHeight, int x1, int y1, int x2, int y2, int destX, int destY ) ;		// `\摜obNobt@ẅ̃OtBbN擾

// Direct3D11 ̃OtBbNnhɉ摜f[^]邽߂̊֐
extern	int		Graphics_Hardware_D3D11_BltBmpOrBaseImageToGraph3_PF(
	const RECT		*SrcRect,
	      int		DestX,
	      int		DestY,
	      int		GrHandle,
	const BASEIMAGE	*RgbBaseImage,
	const BASEIMAGE	*AlphaBaseImage,
	      int		RedIsAlphaFlag,
	      int		UseTransColorConvAlpha,
	      int		TargetOrig,
	      int		ASyncThread
) ;

extern	int		Graphics_Hardware_D3D11_CreateOrigTexture_PF(  IMAGEDATA_ORIG *Orig, int ASyncThread = FALSE ) ;	// IWi摜񒆂̃eNX`쐬( 0:  -1:s )
extern	int		Graphics_Hardware_D3D11_ReleaseOrigTexture_PF( IMAGEDATA_ORIG *Orig ) ;								// IWi摜񒆂̃eNX`
extern	int		Graphics_Hardware_D3D11_GetMultiSampleQuality_PF( int Samples ) ;									// w̃}`TvŎgpłőNIeBl擾
extern	int		Graphics_Hardware_D3D11_SetUsePlatformTextureFormat_PF( int PlatformTextureFormat ) ;				// 쐬OtBbNnhŎgpˑ̃eNX`tH[}bgw肷








// ˑ_obt@ECfbNXobt@֌W
extern	int		Graphics_Hardware_D3D11_VertexBuffer_Create_PF(    VERTEXBUFFERHANDLEDATA *VertexBuffer ) ;															// _obt@nh̒_obt@쐬
extern	int		Graphics_Hardware_D3D11_VertexBuffer_Terminate_PF( VERTEXBUFFERHANDLEDATA *VertexBuffer ) ;															// _obt@nȟn
extern	int		Graphics_Hardware_D3D11_VertexBuffer_SetData_PF(   VERTEXBUFFERHANDLEDATA *VertexBuffer, int SetIndex, const void *VertexData, int VertexNum ) ;	// _obt@ɒ_f[^]
extern	int		Graphics_Hardware_D3D11_IndexBuffer_Create_PF(     INDEXBUFFERHANDLEDATA *IndexBuffer ) ;															// CfbNXobt@nh̃ZbgAbvs
extern	int		Graphics_Hardware_D3D11_IndexBuffer_Terminate_PF(  INDEXBUFFERHANDLEDATA *IndexBuffer ) ;															// CfbNXobt@nȟn
extern	int		Graphics_Hardware_D3D11_IndexBuffer_SetData_PF(    INDEXBUFFERHANDLEDATA *IndexBuffer, int SetIndex, const void *IndexData, int IndexNum ) ;		// CfbNXobt@ɃCfbNXf[^]









// ˑCg֌W
extern	int		Graphics_Hardware_D3D11_Light_SetUse_PF( int Flag ) ;															// CeBOsǂݒ肷
extern	int		Graphics_Hardware_D3D11_Light_GlobalAmbient_PF( COLOR_F *Color ) ;												// O[oArGgCgJ[ݒ肷
extern	int		Graphics_Hardware_D3D11_Light_SetState_PF( int LightNumber, LIGHTPARAM *LightParam ) ;							// Cgp[^Zbg
extern	int		Graphics_Hardware_D3D11_Light_SetEnable_PF( int LightNumber, int EnableState ) ;									// Cg̗LAύX








// ˑVhE}bv֌W
extern	int		Graphics_Hardware_D3D11_ShadowMap_CreateTexture_PF( SHADOWMAPDATA *ShadowMap, int ASyncThread = FALSE ) ;		// VhE}bvf[^ɕKvȃeNX`쐬
extern	int		Graphics_Hardware_D3D11_ShadowMap_ReleaseTexture_PF( SHADOWMAPDATA *ShadowMap ) ;								// VhE}bvf[^ɕKvȃeNX`
extern	void	Graphics_Hardware_D3D11_ShadowMap_RefreshVSParam_PF( void ) ;													// _VF[_[ɐݒ肷VhE}bv̏XV
extern	void	Graphics_Hardware_D3D11_ShadowMap_RefreshPSParam_PF( void ) ;													// sNZVF[_[ɐݒ肷VhE}bv̏XV
extern	int		Graphics_Hardware_D3D11_ShadowMap_DrawSetup_PF( SHADOWMAPDATA *ShadowMap ) ;										// VhE}bvւ̕`̏s
extern	int		Graphics_Hardware_D3D11_ShadowMap_DrawEnd_PF( SHADOWMAPDATA *ShadowMap ) ;										// VhE}bvւ̕`I
extern	int		Graphics_Hardware_D3D11_ShadowMap_SetUse_PF( int SlotIndex, SHADOWMAPDATA *ShadowMap ) ;							// `ŎgpVhE}bvw肷AXbg͂OPw\








// ˑVF[_[֌W
extern	int		Graphics_Hardware_D3D11_Shader_Create_PF( int ShaderHandle, int IsVertexShader, void *Image, int ImageSize, int ImageAfterFree, int ASyncThread ) ;		// VF[_[nh
extern	int		Graphics_Hardware_D3D11_Shader_TerminateHandle_PF( SHADERHANDLEDATA *Shader ) ;																			// VF[_[nȟn
extern	int		Graphics_Hardware_D3D11_Shader_GetValidShaderVersion_PF( void ) ;																							// gpłVF[_[̃o[W擾( 0=gȂ  200=VF[_[fQDOgp\  300=VF[_[fRDOgp\ )
extern	int		Graphics_Hardware_D3D11_Shader_GetConstIndex_PF( const wchar_t *ConstantName, SHADERHANDLEDATA *Shader ) ;													// w̖O萔gpVF[_[萔̔ԍ擾
extern	int		Graphics_Hardware_D3D11_Shader_GetConstCount_PF( const wchar_t *ConstantName, SHADERHANDLEDATA *Shader ) ;													// w̖O萔gpVF[_[萔̐擾
extern	const FLOAT4 *Graphics_Hardware_D3D11_Shader_GetConstDefaultParamF_PF( const wchar_t *ConstantName, SHADERHANDLEDATA *Shader ) ;									// w̖O_萔̃ftHgp[^i[Ă郁AhX擾
extern	int		Graphics_Hardware_D3D11_Shader_SetConst_PF(   int TypeIndex, int SetIndex, int ConstantIndex, const void *Param, int ParamNum, int UpdateUseArea ) ;	// VF[_[萔ݒ肷
extern	int		Graphics_Hardware_D3D11_Shader_ResetConst_PF( int TypeIndex, int SetIndex, int ConstantIndex, int ParamNum ) ;											// ẅ̃VF[_[萔Zbg
extern	int		Graphics_Hardware_D3D11_Shader_ModelCode_Init_PF( void ) ;																								// Rcfp̃VF[_[R[h̏s








// ˑVF[_[p萔obt@֌W
extern	int		Graphics_Hardware_D3D11_ShaderConstantBuffer_Create_PF( int ShaderConstantBufferHandle, int BufferSize, int ASyncThread ) ;												// VF[_[p萔obt@nh
extern	int		Graphics_Hardware_D3D11_ShaderConstantBuffer_TerminateHandle_PF( SHADERCONSTANTBUFFERHANDLEDATA *ShaderConstantBuffer ) ;													// VF[_[p萔obt@nȟn
extern	void *	Graphics_Hardware_D3D11_ShaderConstantBuffer_GetBuffer_PF( SHADERCONSTANTBUFFERHANDLEDATA *ShaderConstantBuffer ) ;														// VF[_[p萔obt@nh̒萔obt@̃AhX擾
extern	int		Graphics_Hardware_D3D11_ShaderConstantBuffer_Update_PF( SHADERCONSTANTBUFFERHANDLEDATA *ShaderConstantBuffer ) ;															// VF[_[p萔obt@nh̒萔obt@ւ̕ύXKp
extern	int		Graphics_Hardware_D3D11_ShaderConstantBuffer_Set_PF( SHADERCONSTANTBUFFERHANDLEDATA *ShaderConstantBuffer, int TargetShader /* DX_SHADERTYPE_VERTEX Ȃ */, int Slot ) ;	// VF[_[p萔obt@nh̒萔obt@w̃VF[_[̎w̃XbgɃZbg








// ˑ`֌W
extern	int		Graphics_Hardware_D3D11_Paint_PF( int x, int y, unsigned int FillColor, ULONGLONG BoundaryColor ) ;			// w_狫EFƂ܂œhԂ






#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // DX_NON_DIRECT3D11

#endif // DX_NON_GRAPHICS

#endif // __DXGRAPHICSD3D11_H__

