// -------------------------------------------------------------------------------
// 
// 		cwCu		Androidp͏vOwb_t@C
// 
// 				Ver 3.17c
// 
// -------------------------------------------------------------------------------

#ifndef __DXINPUTANDROID_H__
#define __DXINPUTANDROID_H__

#include "../DxCompileConfig.h"

#ifndef DX_NON_INPUT

// CN[h ------------------------------------------------------------------
#include "../DxLib.h"
#include <Android/input.h>

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------

#define ANDR_INPUT_LOG_NUM					(64)
#define ANDR_DEVICE_MAX_NUM					(64)

// ̓\[X
#define ANDR_INPUT_SOURCE_UNKNOWN			(0)
#define ANDR_INPUT_SOURCE_KEYBOARD			(1)
#define ANDR_INPUT_SOURCE_DPAD				(2)
#define ANDR_INPUT_SOURCE_GAMEPAD			(3)
#define ANDR_INPUT_SOURCE_TOUCHSCREEN		(4)
#define ANDR_INPUT_SOURCE_MOUSE				(5)
#define ANDR_INPUT_SOURCE_STYLUS			(6)
#define ANDR_INPUT_SOURCE_TRACKBALL			(7)
#define ANDR_INPUT_SOURCE_TOUCHPAD			(8)
#define ANDR_INPUT_SOURCE_TOUCH_NAVIGATION	(9)
#define ANDR_INPUT_SOURCE_JOYSTICK			(10)
#define ANDR_INPUT_SOURCE_NUM				(11)

// \̒` --------------------------------------------------------------------

// Ůˑ
struct INPUTVIBRATIONDATA_PF
{
	int						Dummy ;
} ;

// Q[pbh̊ˑ
struct INPUTPADDATA_PF
{
	int						Dummy ;
} ;

// ̓̓foCX̓͏
struct INPUT_ANDROID_DEVICE_INFO
{
	int32_t					Source ;
	int32_t					DeviceId ;
	LONGLONG				UpdateCount ;
	BYTE					KeyState[ 256 ] ;
	int32_t					ButtonState ;
	BYTE					PointerState[ 256 ] ;
	float					AxisX ;
	float					AxisY ;
	float					AxisZ ;
	float					AxisRx ;
	float					AxisRy ;
	float					AxisRz ;
	float					AxisHatX ;
	float					AxisHatY ;
	float					AxisLTrigger ;
	float					AxisRTrigger ;
	float					Wheel ;
} ;

// ̓VXepˑf[^\̌^
struct INPUTSYSTEMDATA_PF
{
	LONGLONG					UpdateCount ;
	int							UseInputInfoNum ;
	INPUT_ANDROID_DEVICE_INFO	InputInfo[ ANDR_DEVICE_MAX_NUM ] ;
	int							SourceNum[ ANDR_INPUT_SOURCE_NUM ] ;
	int							SourceNoToInputInfoTable[ ANDR_INPUT_SOURCE_NUM ][ ANDR_DEVICE_MAX_NUM ] ;
	TOUCHINPUTDATA				TouchInputData ;
} ;

// ϐ錾 --------------------------------------------------------------

// ֐vg^Cv錾-----------------------------------------------------------

extern	int GetAndroidDeviceIdToInputInfoNo( int32_t Source, int32_t DeviceId ) ;	// foCXhclׂ͏ԍ擾
extern	int RefreshAndroidSourceNoToInputInfoTable( int32_t Source ) ;				// ̓\[XԍƓ͏Ƃ̑Ήe[uXV
extern	int32_t ProcessInputEvent( AInputEvent* event ) ;							// ̓Cxg

#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // DX_NON_INPUT

#endif // __DXINPUTANDROID_H__
